<?php
if ( ! defined( 'ABSPATH' ) ) exit;
/**
 * Fired during plugin activation
 *
 * @link       http://myworks.design/software/wordpress/woocommerce/myworks-wc-qbo-sync
 * @since      1.0.0
 *
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    MW_QBO_Desktop
 * @subpackage MW_QBO_Desktop/includes
 * @author     My Works <support@myworks.design>
 */

class MW_QBO_Desktop_Sync_Qwc_Server_Lib extends MW_QBO_Desktop_Sync_Lib{
	private $qbd_timezone;
	private $debug_queue;
	public function __construct($dsn){
		if(!session_id()) {
			session_start();
		}
		
		parent::__construct();
		
		if($this->dsn && QuickBooks_Utilities::initialized($this->dsn)){
			QuickBooks_WebConnector_Queue_Singleton::initialize($this->dsn);
		}

		if (function_exists('date_default_timezone_set')){			
			$qbd_tz_setting = $this->get_qbd_timezone();
			//$qbd_tz_setting = 'America/New_York';
			date_default_timezone_set($qbd_tz_setting);
			$this->qbd_timezone = $qbd_tz_setting;
		}
		
		if(isset($_GET['debug'])){
			$this->debug();
		}
		
		//$this->debug_queue = true;
	}
	
	public function debug(){
		$order_id = 351;
		$order_id_ext = 0;
		//echo $this->GetProductQbxml(75,'Inventory');
		//echo $this->GetProductQbxml(42,'NonInventory');
		//echo $this->GetSalesReceiptQbxml($order_id);
		//echo $this->GetSalesReceiptQbxml_GPI($order_id_ext);
		//echo $this->GetSalesOrderQbxml($order_id);
		//echo $this->GetEstimateQbxml($order_id);
		//$this->_p($this->get_order_base_currency_total_from_order_id(0));		
		//$this->_p($this->get_wc_order_details_from_order($order_id,get_post($order_id)));
		//$this->_p($this->get_wc_order_details_from_order(346,get_post(346)));
		//$this->_p($this->get_wc_country_list());
		//echo $this->GetInvoiceQbxml($order_id);
		//echo $this->GetPurchaseOrderQbxml($order_id);
		//echo $this->GetCustomerQbxml(3);
		//echo $this->GetCustomerQbxml($order_id,true);
		
		/*
		$customer_data = $this->get_wc_customer_info_from_order($order_id);
		$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
		$this->_p($customer_data);
		$this->_p($qbo_cus_id,true);
		*/
		
		//$this->_p($this->get_wc_customer_info(11));
		//$this->_p($this->get_wc_customer_info_from_order(305));
		
		//echo $this->GetPaymentQbxml(10969);
		//echo $this->GetInventoryAdjustmentAddQbxml(76);
		//$this->_p($this->get_wc_variation_info(86));
		//echo $this->GetProductQbxml(86,'NonInventory',1);
		//echo $this->server_timezone;
		//echo $this->get_auto_inventory_pull_m_dt_from();
		//$user_data = get_userdata(17);
		//$this->_p($user_data);		
		//echo $this->GetRefundQbxml_Check(284,283);
		//die;
		
		/*
		if($this->check_cg_ibn($this->get_wc_customer_info_from_order(310))){
			echo 'Testing...';
		}
		*/
		
		/*
		if($this->check_cf_map_data_ext_field_value_exists(317,'Invoice')){
			echo 'Testing...';
		}
		*/
		//echo $this->GetOrderDataExtAddQbxml(317,array('Qos_Type'=>'Invoice','TxnID'=>'000-000000000000'));
		//$this->oth_debug_function();
	}
	
	private function oth_debug_function(){
		//
	}
	
	public function Debug_Queue_Request($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $version, $locale){
		if(!$this->is_qwc_connected()){
			return false;
		}
		
		// Build the request
		/*
		$xml = '<?xml version="1.0" encoding="utf-8"?>
		<?qbxml version="' . $version . '"?>
		<QBXML>
			<QBXMLMsgsRq onError="'.$this->getonError().'">
				<CustomerQueryRq  requestID="' . $requestID . '">
				<ListID >80000005-1515687113</ListID>
				<OwnerID >0</OwnerID>
				</CustomerQueryRq >
			</QBXMLMsgsRq>
		</QBXML>';
		*/
		
		$display_name = 'New Testing Filter';
		$xml = '<?xml version="1.0" encoding="utf-8"?>
		<?qbxml version="' . $version . '"?>
		<QBXML>
			<QBXMLMsgsRq onError="'.$this->getonError().'">
				<CustomerQueryRq requestID="' . $requestID . '">
					<NameFilter>
						<MatchCriterion>Contains</MatchCriterion>
						<Name>'.$display_name.'</Name>
					</NameFilter>								
				</CustomerQueryRq>
			</QBXMLMsgsRq>
		</QBXML>';
		
		$this->add_test_log($xml);
		return $xml;
	}
	
	public function Debug_Queue_response($requestID, $user, $action, $ID, $extra, &$err, $last_action_time, $last_actionident_time, $xml, $idents){
		if(!$this->is_qwc_connected()){
			return false;
		}
		$this->add_test_log($xml);
	}

	private function getonError(){
		$onError = 'continueOnError';//stopOnError
		return $onError;
	}

	private function get_qbxml_prefix($version='6.0'){
		$version = '13.0';
		$xml_encoding = $this->get_option('mw_wc_qbo_desk_xml_req_encoding');
		if($xml_encoding!='utf-8' && $xml_encoding!='ISO-8859-1'){
			$xml_encoding = 'utf-8';
		}
		//qbxml version="2.0"
		return '
			<?xml version="1.0" encoding="'.$xml_encoding.'"?>
			<?qbxml version="'.$version.'"?>
			<QBXML>
			<QBXMLMsgsRq onError="'.$this->getonError().'">
		';
		//continueOnError#stopOnError
	}

	private function get_qbxml_suffix(){
		return '
			</QBXMLMsgsRq>
			</QBXML>
		';
	}
	
	public function get_qbxml_locale(){
		$sl = trim($this->get_option('mw_wc_qbo_desk_xml_req_locale'));
		if($sl==''){$sl = 'US';}
		return $sl;
	}
	
	/*QBXML Functions*/
	
	public function GetPurchaseOrderQbxml($order_id,$update=false){
		if($this->is_qwc_connected()){
			if(!$this->ord_pmnt_is_mt_ls_check_by_ord_id($order_id)){
				return false;
			}
			
			$order = get_post($order_id);
			$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
			//$this->_p($invoice_data);
			if(is_array($invoice_data) && count($invoice_data)){
				global $wpdb;
				
				$wc_cus_id = (int) $this->get_array_isset($invoice_data,'wc_cus_id',0);
				$qbo_cus_id = '';
				
				$wc_inv_id = (int) $this->get_array_isset($invoice_data,'wc_inv_id',0);
				$wc_inv_num = $this->get_array_isset($invoice_data,'wc_inv_num','');
				
				$_order_currency = $this->get_array_isset($invoice_data,'_order_currency','',true);
				
				$qbo_vendor_id = $this->get_option('mw_wc_qbo_desk_compt_socpo_qbd_vendor');
				if(empty($qbo_vendor_id)){
					$this->save_log(array('log_type'=>'PurchaseOrder','log_title'=>'Export PurchaseOrder Error #'.$order_id,'details'=>'QuickBooks Vendor Not Found','status'=>0));
					return false;
				}
				
				$qbd_vendor_data = $this->get_row($wpdb->prepare("SELECT * FROM {$wpdb->prefix}mw_wc_qbo_desk_qbd_vendors WHERE `qbd_vendorid` = %s",$qbo_vendor_id));
				if(empty($qbd_vendor_data)){
					$this->save_log(array('log_type'=>'PurchaseOrder','log_title'=>'Export PurchaseOrder Error #'.$order_id,'details'=>'QuickBooks Vendor Not Found','status'=>0));
					return false;
				}
				
				$DocNumber = ($wc_inv_num!='')?$wc_inv_num:$wc_inv_id;
				$DocNumber_Po = 'PO-'.$DocNumber;
				
				$PurchaseOrder = new QuickBooks_QBXML_Object_PurchaseOrder();
				$PurchaseOrder->set('RefNumber',$DocNumber_Po);
				
				$PurchaseOrder->set('Memo',$DocNumber);
				
				$PurchaseOrder->set('VendorRef ListID',$qbo_vendor_id);
				
				$wc_inv_date = $this->get_array_isset($invoice_data,'wc_inv_date','');
				$wc_inv_date = $this->format_date($wc_inv_date);
				if($wc_inv_date!=''){
					$PurchaseOrder->set('TxnDate',$wc_inv_date);
				}

				$wc_inv_due_date = $this->get_array_isset($invoice_data,'wc_inv_due_date','');
				$wc_inv_due_date = $this->format_date($wc_inv_due_date);
				if($wc_inv_due_date!=''){
					$PurchaseOrder->set('DueDate',$wc_inv_due_date);
				}
				
				
				$_payment_method = $this->get_array_isset($invoice_data,'_payment_method','',true);
				
				//
				$qbo_inv_items = (isset($invoice_data['qbo_inv_items']))?$invoice_data['qbo_inv_items']:array();
				if(is_array($qbo_inv_items) && count($qbo_inv_items)){
					foreach($qbo_inv_items as $qbo_item){
						if(isset($qbo_item['socpo_manage_stock']) && $qbo_item['socpo_manage_stock'] == 'yes'){
							if(isset($qbo_item['socpo_stock']) && floatval($qbo_item['socpo_stock']) <= 0){
								$PurchaseOrderLine = new QuickBooks_QBXML_Object_PurchaseOrder_PurchaseOrderLine();
								$PurchaseOrderLine->set('ItemRef ListID',$qbo_item["ItemRef"]);
								
								if(isset($qbo_item["ClassRef"]) && $qbo_item["ClassRef"]!=''){
									$PurchaseOrderLine->set('ClassRef ListID',$qbo_item["ClassRef"]);
								}
								
								$Description = $qbo_item['Description'];
								if($this->option_checked('mw_wc_qbo_desk_add_sku_af_lid')){
									$li_item_id = ($qbo_item["variation_id"]>0)?$qbo_item["variation_id"]:$qbo_item["product_id"];
									$li_sku = get_post_meta( $li_item_id, '_sku', true );
									if($li_sku!=''){
										$Description.=' ('.$li_sku.')';
									}
								}
								
								//Extra Description
								if(isset($qbo_item["Qbd_Ext_Description"])){
									$Description.= $qbo_item["Qbd_Ext_Description"];
								}
								
								if(!$this->option_checked('mw_wc_qbo_desk_skip_os_lid') || $qbo_item["AllowPvLid"]){
									$PurchaseOrderLine->set('Desc',$Description);
								}							
								
								$UnitPrice = $qbo_item["UnitPrice"];
								$Qty = $qbo_item["Qty"];
								$Amount = $Qty*$UnitPrice;
								
								//$PurchaseOrderLine->set('Rate',$UnitPrice);
								$PurchaseOrderLine->set('Quantity',$Qty);
								//$PurchaseOrderLine->set('Amount',$Amount);
								
								$PurchaseOrder->addPurchaseOrderLine($PurchaseOrderLine);
							}
						}
					}
				}
				
				$qbdv_info_arr = $qbd_vendor_data['info_arr'];
				if(!empty($qbdv_info_arr)){					
					$qbdv_info_arr = @unserialize($qbdv_info_arr);
				}
				
				if(is_array($qbdv_info_arr) && count($qbdv_info_arr)){					
					if(!empty($qbdv_info_arr['VendorAddress_Addr1'])){
						$PurchaseOrder->set('VendorAddress Addr1',$qbdv_info_arr['VendorAddress_Addr1']);
						$PurchaseOrder->set('VendorAddress Addr2',$qbdv_info_arr['VendorAddress_Addr2']);
						$PurchaseOrder->set('VendorAddress Addr3',$qbdv_info_arr['VendorAddress_Addr3']);
						$PurchaseOrder->set('VendorAddress Addr4',$qbdv_info_arr['VendorAddress_Addr4']);
						$PurchaseOrder->set('VendorAddress Addr5',$qbdv_info_arr['VendorAddress_Addr5']);
						
						$PurchaseOrder->set('VendorAddress City',$qbdv_info_arr['VendorAddress_City']);
						$PurchaseOrder->set('VendorAddress State',$qbdv_info_arr['VendorAddress_State']);
						$PurchaseOrder->set('VendorAddress PostalCode',$qbdv_info_arr['VendorAddress_PostalCode']);
						$PurchaseOrder->set('VendorAddress Country',$qbdv_info_arr['VendorAddress_Country']);
						
						if(isset($qbdv_info_arr['VendorAddress_Note'])){
							$PurchaseOrder->set('VendorAddress Note',$qbdv_info_arr['VendorAddress_Note']);
						}
					}
					
					/*
					if(!empty($qbdv_info_arr['ShipAddress_Addr1'])){
						$PurchaseOrder->set('ShipAddress Addr1',$qbdv_info_arr['ShipAddress_Addr1']);
						$PurchaseOrder->set('ShipAddress Addr2',$qbdv_info_arr['ShipAddress_Addr2']);
						$PurchaseOrder->set('ShipAddress Addr3',$qbdv_info_arr['ShipAddress_Addr3']);
						$PurchaseOrder->set('ShipAddress Addr4',$qbdv_info_arr['ShipAddress_Addr4']);
						$PurchaseOrder->set('ShipAddress Addr5',$qbdv_info_arr['ShipAddress_Addr5']);
						
						$PurchaseOrder->set('ShipAddress City',$qbdv_info_arr['ShipAddress_City']);
						$PurchaseOrder->set('ShipAddress State',$qbdv_info_arr['ShipAddress_State']);
						$PurchaseOrder->set('ShipAddress PostalCode',$qbdv_info_arr['ShipAddress_PostalCode']);
						$PurchaseOrder->set('ShipAddress Country',$qbdv_info_arr['ShipAddress_Country']);
						
						if(isset($qbdv_info_arr['ShipAddress_Note'])){
							$PurchaseOrder->set('ShipAddress Note',$qbdv_info_arr['ShipAddress_Note']);
						}
					}
					*/
				}
				
				if($this->get_array_isset($invoice_data,'_shipping_first_name','',true)!=''){
					$_shipping_first_name = $this->get_array_isset($invoice_data,'_shipping_first_name','',true);
					$_shipping_last_name = $this->get_array_isset($invoice_data,'_shipping_last_name','',true);
					
					$country = $this->get_array_isset($invoice_data,'_shipping_country','',true);
					$country = $this->get_country_name_from_code($country);
					
					$_shipping_company = $this->get_array_isset($invoice_data,'_shipping_company','',true);
					$_shipping_address_1 = $this->get_array_isset($invoice_data,'_shipping_address_1','',true);
					$_shipping_address_2 = $this->get_array_isset($invoice_data,'_shipping_address_2','',true);
					$_shipping_city = $this->get_array_isset($invoice_data,'_shipping_city','',true);
					$_shipping_state = $this->get_array_isset($invoice_data,'_shipping_state','',true);
					$_shipping_postcode = $this->get_array_isset($invoice_data,'_shipping_postcode','',true);
					
					$rfs_arr = array($_shipping_first_name,$_shipping_last_name,$_shipping_company,$_shipping_address_1,$_shipping_address_2,$_shipping_city,$_shipping_state,$_shipping_postcode,$country);
					
					$r_fa = $this->get_ord_saf_addrs($rfs_arr);
					$PurchaseOrder->set('ShipAddress Addr1',$this->get_array_isset($r_fa,0,'',true));
					$PurchaseOrder->set('ShipAddress Addr2',$this->get_array_isset($r_fa,1,'',true));
					$PurchaseOrder->set('ShipAddress Addr3',$this->get_array_isset($r_fa,2,'',true));
					$PurchaseOrder->set('ShipAddress Addr4',$this->get_array_isset($r_fa,3,'',true));
					$PurchaseOrder->set('ShipAddress Addr5',$this->get_array_isset($r_fa,4,'',true));
				}
				
				//$this->_p($PurchaseOrder);
				
				$qbxml = $PurchaseOrder->asQBXML(QUICKBOOKS_ADD_PURCHASE_ORDER,null,$this->get_qbxml_locale());					
				$qbxml = $this->get_qbxml_prefix().$qbxml. $this->get_qbxml_suffix();					

				return $qbxml;
			}
		}
	}
	
	//
	public function GetInvoiceQbxml($order_id,$extra=null){
		if($this->is_qwc_connected()){
			if(!$this->ord_pmnt_is_mt_ls_check_by_ord_id($order_id)){
				return false;
			}
			
			$order = get_post($order_id);
			$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
			//$this->add_test_log(print_r($invoice_data,true));
			//$this->_p($invoice_data);
			if(is_array($invoice_data) && count($invoice_data)){
				global $wpdb;
				$wc_cus_id = (int) $this->get_array_isset($invoice_data,'wc_cus_id',0);
				$qbo_cus_id = '';

				$wc_inv_id = (int) $this->get_array_isset($invoice_data,'wc_inv_id',0);
				$wc_inv_num = $this->get_array_isset($invoice_data,'wc_inv_num','');
				
				$_order_currency = $this->get_array_isset($invoice_data,'_order_currency','',true);				
				
				if($this->is_plugin_active('woocommerce-aelia-currencyswitcher') && $this->option_checked('mw_wc_qbo_desk_wacs_satoc_cb')){				
					if($_order_currency!=''){
						$aelia_cur_cus_map = get_option('mw_wc_qbo_desk_wacs_satoc_map_cur_cus');
						if(is_array($aelia_cur_cus_map) && count($aelia_cur_cus_map)){
							if(isset($aelia_cur_cus_map[$_order_currency]) && trim($aelia_cur_cus_map[$_order_currency])!=''){
								$qbo_cus_id = trim($aelia_cur_cus_map[$_order_currency]);
							}
						}
					}					
				}
				
				/**/
				if($this->is_plugin_active('myworks-quickbooks-desktop-sync-compatibility') && $this->is_plugin_active('myworks-quickbooks-desktop-shipping-us-state-quickbooks-customer-map-compt') && $this->option_checked('mw_wc_qbo_desk_compt_sus_qb_cus_map_ed')){					
					if($wc_cus_id>0){						
						$shipping_country = get_user_meta($wc_cus_id,'shipping_country',true);						
					}else{						
						//$shipping_country = get_post_meta($wc_inv_id,'_shipping_country',true);
						$shipping_country = $this->get_array_isset($invoice_data,'_shipping_country','');
					}
					
					if($shipping_country == 'US'){
						if($wc_cus_id>0){
							$shipping_state = get_user_meta($wc_cus_id,'shipping_state',true);
						}else{
							//$shipping_state = get_post_meta($wc_inv_id,'_shipping_state',true);
							$shipping_state = $this->get_array_isset($invoice_data,'_shipping_state','');
						}
						
						if($shipping_state!=''){
							$sus_qb_cus_map = get_option('mw_wc_qbo_desk_ship_us_st_qb_cus_map');
							if(is_array($sus_qb_cus_map) && count($sus_qb_cus_map)){
								if(isset($sus_qb_cus_map[$shipping_state]) && trim($sus_qb_cus_map[$shipping_state])!=''){
									$qbo_cus_id = trim($sus_qb_cus_map[$shipping_state]);
								}
							}
						}
					}else{
						$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_sus_fb_qb_cus_foc');
					}
				}
				
				if(empty($qbo_cus_id)){
					if(!$this->option_checked('mw_wc_qbo_desk_all_order_to_customer')){
						if($wc_cus_id>0){
							//$qbo_cus_id = $this->get_wc_data_pair_val('Customer',$wc_cus_id);
							if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
								$customer_data = $this->get_wc_customer_info_from_order($order_id);
							}else{
								$customer_data = $this->get_wc_customer_info($wc_cus_id);
							}						
							//$this->_p($customer_data);
							$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
						}else{
							$customer_data = $this->get_wc_customer_info_from_order($order_id);
							$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
						}
					}else{
						/*
						if($wc_cus_id>0){
							$user_info = get_userdata($wc_cus_id);
							$io_cs = false;
							if(isset($user_info->roles) && is_array($user_info->roles)){
								$sc_roles_as_cus = $this->get_option('mw_wc_qbo_desk_wc_cust_role_sync_as_cus');
								if(!empty($sc_roles_as_cus)){
									$sc_roles_as_cus = explode(',',$sc_roles_as_cus);
									if(is_array($sc_roles_as_cus) && count($sc_roles_as_cus)){
										foreach($sc_roles_as_cus as $sr){
											if(in_array($sr,$user_info->roles)){
												$io_cs = true;
												break;
											}
										}
									}
								}
							}
							
							if($io_cs){
								if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
									$customer_data = $this->get_wc_customer_info_from_order($order_id);
								}else{
									$customer_data = $this->get_wc_customer_info($wc_cus_id);
								}							
								$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
							}else{
								$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_customer_to_sync_all_orders');
							}
							
						}else{
							$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_customer_to_sync_all_orders');
						}
						*/
						
						/**/
						$wc_user_role = '';
						if($wc_cus_id>0){
							$user_info = get_userdata($wc_cus_id);
							if(isset($user_info->roles) && is_array($user_info->roles)){
								$wc_user_role = $user_info->roles[0];
							}
						}else{
							$wc_user_role = 'wc_guest_user';
						}
						
						if(!empty($wc_user_role)){
							$io_cs = true;
							$mw_wc_qbo_desk_aotc_rcm_data = get_option('mw_wc_qbo_desk_aotc_rcm_data');
							if(is_array($mw_wc_qbo_desk_aotc_rcm_data) && !empty($mw_wc_qbo_desk_aotc_rcm_data)){
								if(isset($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role]) && !empty($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role])){
									if($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role] != 'Individual'){
										$io_cs = false;
									}
								}
							}
							
							if($io_cs){
								if($wc_cus_id>0){
									if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
										$customer_data = $this->get_wc_customer_info_from_order($order_id);
									}else{
										$customer_data = $this->get_wc_customer_info($wc_cus_id);
									}							
									$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
								}else{
									$customer_data = $this->get_wc_customer_info_from_order($order_id);
									$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
								}
							}else{
								$qbo_cus_id = $mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role];
							}
						}
						//
					}
				}				
				
				if(empty($qbo_cus_id)){
					$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order Error #'.$order_id,'details'=>'QuickBooks Customer Not Found','status'=>0));
					return false;
				}

				if($qbo_cus_id!=''){
					$DocNumber = ($wc_inv_num!='')?$wc_inv_num:$wc_inv_id;
					$Invoice = new QuickBooks_QBXML_Object_Invoice();

					//$Invoice->setCustomerName();
					$Invoice->setCustomerListID($qbo_cus_id);
					
					if(!$this->option_checked('mw_wc_qbo_desk_use_qb_in_sr_so_ref_num')){
						$Invoice->setRefNumber($DocNumber);
					}
					
					/**/
					$TemplateRef = $this->get_array_isset($invoice_data,'TemplateRef','');
					if(!empty($TemplateRef)){
						$Invoice->set('TemplateRef ListID', $TemplateRef);
					}
					
					$inv_sr_txn_class = $this->get_option('mw_wc_qbo_desk_inv_sr_txn_qb_class');
					if($inv_sr_txn_class!=''){
						$Invoice->setClassListID($inv_sr_txn_class);
					}
					
					//PO
					if($this->is_plugin_active('split-order-custom-po-for-myworks-quickbooks-desktop-sync') && $this->option_checked('mw_wc_qbo_desk_compt_p_ad_socpo_ed')){
						if(!empty($this->get_option('mw_wc_qbo_desk_compt_socpo_qbd_vendor'))){
							$DocNumber_Po = 'PO-'.$DocNumber;
							$Invoice->set('PONumber',$DocNumber_Po);
						}
					}
					
					
					//NP Billing State - QBD Class Map					
					if($this->option_checked('mw_wc_qbo_desk_compt_np_bus_qbc_map_ed')){
						$_billing_state = $this->get_array_isset($invoice_data,'_billing_state','',true);
						if(!empty($_billing_state)){
							$bus_qbc_map = get_option('mw_wc_qbo_desk_np_bill_us_st_qb_cl_map');
							if(is_array($bus_qbc_map) && count($bus_qbc_map)){
								if(isset($bus_qbc_map[$_billing_state]) && !empty($bus_qbc_map[$_billing_state])){
									$qbd_classid = $bus_qbc_map[$_billing_state];
									$Invoice->setClassListID($qbd_classid);
								}
							}
						}						
					}
					
					$wc_inv_date = $this->get_array_isset($invoice_data,'wc_inv_date','');
					$wc_inv_date = $this->format_date($wc_inv_date);
					if($wc_inv_date!=''){
						$Invoice->setTxnDate($wc_inv_date);
					}

					$wc_inv_due_date = $this->get_array_isset($invoice_data,'wc_inv_due_date','');
					$wc_inv_due_date = $this->format_date($wc_inv_due_date);
					if($wc_inv_due_date!=''){
						$Invoice->setDueDate($wc_inv_due_date);
					}
					
					
					$_payment_method = $this->get_array_isset($invoice_data,'_payment_method','',true);
					
					/*Count Total Amounts*/
					$_cart_discount = $this->get_array_isset($invoice_data,'_cart_discount',0);
					$_cart_discount_tax = $this->get_array_isset($invoice_data,'_cart_discount_tax',0);

					$_order_tax = (float) $this->get_array_isset($invoice_data,'_order_tax',0);
					$_order_shipping_tax = (float) $this->get_array_isset($invoice_data,'_order_shipping_tax',0);
					$_order_total_tax = ($_order_tax+$_order_shipping_tax);

					$order_shipping_total = $this->get_array_isset($invoice_data,'order_shipping_total',0);
					
					if($this->wacs_base_cur_enabled()){
						$_cart_discount_base_currency = $this->get_array_isset($invoice_data,'_cart_discount_base_currency',0);
						$_cart_discount_tax_base_currency = $this->get_array_isset($invoice_data,'_cart_discount_tax_base_currency',0);
						
						$_order_tax_base_currency = (float) $this->get_array_isset($invoice_data,'_order_tax_base_currency',0);
						$_order_shipping_tax_base_currency = (float) $this->get_array_isset($invoice_data,'_order_shipping_tax_base_currency',0);
						$_order_total_tax_base_currency = ($_order_tax_base_currency+$_order_shipping_tax_base_currency);
						
						$order_shipping_total_base_currency = $this->get_array_isset($invoice_data,'_order_shipping_base_currency',0);
					}
					
					/*Qbd settings*/
					$qbo_is_sales_tax = true;
					$qbo_company_country = 'US';
					$qbo_is_shipping_allowed = false;

					/*Tax rates*/
					$qbo_tax_code = '';
					$apply_tax = false;
					$is_tax_applied = false;
					$is_inclusive = false;

					$qbo_tax_code_shipping = '';

					$tax_rate_id = 0;
					$tax_rate_id_2 = 0;

					$tax_details = (isset($invoice_data['tax_details']))?$invoice_data['tax_details']:array();
					
					//Tax Totals From tax Lines
					$calc_order_tax_totals_from_tax_lines = true;					
					if($calc_order_tax_totals_from_tax_lines){
						$_order_tax = 0;
						$_order_shipping_tax = 0;
						$_order_total_tax = 0;
						
						if($this->wacs_base_cur_enabled()){
							$_order_tax_base_currency = 0;
							$_order_shipping_tax_base_currency = 0;
							$_order_total_tax_base_currency = 0;
						}
						
						if(count($tax_details)){
							foreach($tax_details as $td){
								$_order_tax+=$td['tax_amount'];
								$_order_shipping_tax+=$td['shipping_tax_amount'];
								$_order_total_tax+=$td['tax_amount']+$td['shipping_tax_amount'];
								
								if($this->wacs_base_cur_enabled()){
									$_order_tax_base_currency+=$td['tax_amount_base_currency'];
									$_order_shipping_tax_base_currency+=$td['shipping_tax_amount_base_currency'];
									$_order_total_tax_base_currency+=$td['tax_amount_base_currency']+$td['shipping_tax_amount_base_currency'];
								}
							}
						}
					}
					$_order_total_tax = $this->qbd_limit_decimal_points($_order_total_tax);
					if($this->wacs_base_cur_enabled()){
						$_order_total_tax_base_currency = $this->qbd_limit_decimal_points($_order_total_tax_base_currency);
					}
					
					//TaxJar Settings
					$is_taxjar_active = false;
					$woocommerce_taxjar_integration_settings = get_option('woocommerce_taxjar-integration_settings');
					$wc_taxjar_enable_tax_calculation = 0;
					if(is_array($woocommerce_taxjar_integration_settings) && count($woocommerce_taxjar_integration_settings)){
						if(isset($woocommerce_taxjar_integration_settings['enabled']) && $woocommerce_taxjar_integration_settings['enabled']=='yes'){
							$wc_taxjar_enable_tax_calculation = 1;
						}
					}
					
					if($this->is_plugin_active('taxjar-simplified-taxes-for-woocommerce','taxjar-woocommerce') && $this->option_checked('mw_wc_qbo_desk_wc_taxjar_support') && $wc_taxjar_enable_tax_calculation=='1'){
						$is_taxjar_active = true;
						$qbo_is_sales_tax = false;
					}
					
					//Avatax Settings
					$is_avatax_active = false;
					$wc_avatax_enable_tax_calculation = get_option('wc_avatax_enable_tax_calculation');
					if($this->is_plugin_active('woocommerce-avatax') && $this->option_checked('mw_wc_qbo_desk_wc_avatax_support') && $wc_avatax_enable_tax_calculation=='yes'){
						$is_avatax_active = true;
						$qbo_is_sales_tax = false;
					}
					
					//
					$is_so_tax_as_li = false;
					if($this->option_checked('mw_wc_qbo_desk_odr_tax_as_li')){
						$is_so_tax_as_li = true;
						$qbo_is_sales_tax = false;
					}
					
					if($qbo_is_sales_tax){
						if(count($tax_details)){
							$tax_rate_id = $tax_details[0]['rate_id'];
						}

						if(count($tax_details)>1){
							if($tax_details[1]['tax_amount']>0){
								$tax_rate_id_2 = $tax_details[1]['rate_id'];
							}
						}

						/*
						if(count($tax_details)>1 && $qbo_is_shipping_allowed){
							foreach($tax_details as $td){
								if($td['tax_amount']==0 && $td['shipping_tax_amount']>0){
									$qbo_tax_code_shipping = $this->get_qbo_mapped_tax_code($td['rate_id'],0);
									break;
								}
							}
						}
						*/
						
						$qbo_tax_code = $this->get_qbo_mapped_tax_code($tax_rate_id,$tax_rate_id_2);
						if($qbo_tax_code!='' || $qbo_tax_code!='NON'){
							$apply_tax = true;
						}

						//$Tax_Code_Details = $this->mod_qbo_get_tx_dtls($qbo_tax_code);
						$is_qbo_dual_tax = false;

						/*
						if(count($Tax_Code_Details)){
							if($Tax_Code_Details['TaxGroup'] && count($Tax_Code_Details['TaxRateDetail'])>1){
								$is_qbo_dual_tax = true;
							}
						}

						$Tax_Rate_Ref = (isset($Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef']:'';
						$TaxPercent = $this->get_qbo_tax_rate_value_by_key($Tax_Rate_Ref);
						$Tax_Name = (isset($Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef_name']:'';

						$NetAmountTaxable = 0;

						if($is_qbo_dual_tax){
							$Tax_Rate_Ref_2 = (isset($Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef']:'';
							$TaxPercent_2 = $this->get_qbo_tax_rate_value_by_key($Tax_Rate_Ref_2);
							$Tax_Name_2 = (isset($Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef_name']:'';
							$NetAmountTaxable_2 = 0;
						}
						*/

						/*
						if($qbo_tax_code_shipping!=''){
							$Tax_Code_Details_Shipping = $this->mod_qbo_get_tx_dtls($qbo_tax_code_shipping);
							$Tax_Rate_Ref_Shipping = (isset($Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef']:'';
							$TaxPercent_Shipping = $this->get_qbo_tax_rate_value_by_key($Tax_Rate_Ref_Shipping);
							$Tax_Name_Shipping = (isset($Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef_name']:'';
							$NetAmountTaxable_Shipping = 0;
						}
						*/

						$_prices_include_tax = $this->get_array_isset($invoice_data,'_prices_include_tax','no',true);
						if($qbo_is_sales_tax){
							$tax_type = $this->get_tax_type($_prices_include_tax);
							$is_inclusive = $this->is_tax_inclusive($tax_type);
						}
					}


					$qbo_inv_items = (isset($invoice_data['qbo_inv_items']))?$invoice_data['qbo_inv_items']:array();
					
					/**/
					if($this->check_sh_paamc_hash()){
						$ARAccountRef = '';
						if(is_array($qbo_inv_items) && count($qbo_inv_items)){
							foreach($qbo_inv_items as $qbo_item){
								if(isset($qbo_item['QbArAccId']) && !empty($qbo_item['QbArAccId'])){
									$ARAccountRef = $qbo_item['QbArAccId'];
								}
							}
						}
						
						if(!empty($ARAccountRef)){
							$Invoice->setARAccountListID($ARAccountRef);
						}
					}					
					
					$is_bundle_order = false;
					$map_bundle_support = false;
					
					if(!$is_bundle_order){
						if(is_array($qbo_inv_items) && count($qbo_inv_items)){
							foreach($qbo_inv_items as $qbo_item){
								if($qbo_item['qbo_product_type'] == 'Group'){
									$map_bundle_support = true;
									$InvoiceLineGroup = new QuickBooks_QBXML_Object_Invoice_InvoiceLineGroup();
									$InvoiceLineGroup->setItemListID($qbo_item["ItemRef"]);
									$Description = $qbo_item['Description'];
									$Qty = $qbo_item["Qty"];									
									$InvoiceLineGroup->setQuantity($Qty);
									
									if(!$this->option_checked('mw_wc_qbo_desk_skip_os_lid')){
										//$InvoiceLineGroup->setDesc($Description);
									}
									//TotalAmount
									$Invoice->addInvoiceLineGroup($InvoiceLineGroup);
								}
							}
						}
					}
					
					if(is_array($qbo_inv_items) && count($qbo_inv_items)){
						foreach($qbo_inv_items as $qbo_item){
							
							if($map_bundle_support && $qbo_item['qbo_product_type'] == 'Group'){
								continue;
							}
							
							$InvoiceLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
							//$InvoiceLine->setItemName($qbo_item['Description']);
							$InvoiceLine->setItemListID($qbo_item["ItemRef"]);
							if(isset($qbo_item["ClassRef"]) && $qbo_item["ClassRef"]!=''){
								$InvoiceLine->setClassListID($qbo_item["ClassRef"]);
							}
							
							$Description = $qbo_item['Description'];
							if($this->option_checked('mw_wc_qbo_desk_add_sku_af_lid')){
								$li_item_id = ($qbo_item["variation_id"]>0)?$qbo_item["variation_id"]:$qbo_item["product_id"];
								$li_sku = get_post_meta( $li_item_id, '_sku', true );
								if($li_sku!=''){
									$Description.=' ('.$li_sku.')';
								}
							}
							
							$UnitPrice = $qbo_item["UnitPrice"];
							if($this->wacs_base_cur_enabled()){
								$UnitPrice = $qbo_item["UnitPrice_base_currency"];
								$Description.= " ({$_order_currency} ".$qbo_item["UnitPrice"].")";
							}
							
							//Extra Description
							if(isset($qbo_item["Qbd_Ext_Description"])){
								$Description.= $qbo_item["Qbd_Ext_Description"];
							}
							
							if(!$this->option_checked('mw_wc_qbo_desk_skip_os_lid') || $qbo_item["AllowPvLid"]){
								$InvoiceLine->setDesc($Description);
							}
							
							$Qty = $qbo_item["Qty"];
							$Amount = $Qty*$UnitPrice;
							$InvoiceLine->setRate($UnitPrice);
							$InvoiceLine->setQuantity($Qty);
							$InvoiceLine->setAmount($Amount);

							/*
							SerialNumber
							LotNumber
							ServiceDate
							*/
							
							if($qbo_is_sales_tax){
								if($apply_tax && $qbo_item["Taxed"]){
									$is_tax_applied = true;
									/*$TaxCodeRef = ($qbo_company_country=='US')?'TAX':$qbo_tax_code;*/
									if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')== 'Sales_Tax_Codes'){
										$TaxCodeRef =$qbo_tax_code;
									}else{
										$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
									}
									
									/*
									if($is_inclusive){
										$TaxInclusiveAmt = ($qbo_item['line_total']+$qbo_item['line_tax']);
									}
									*/
									if($TaxCodeRef!=''){
										$InvoiceLine->setSalesTaxCodeListID($TaxCodeRef);
									}
								}else{
									$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
									$InvoiceLine->setSalesTaxCodeListID($zero_rated_tax_code);
								}
							}
							
							if(!$qbo_is_sales_tax){
								$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
								$InvoiceLine->setSalesTaxCodeListID($zero_rated_tax_code);
							}
							
							if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync') && ($qbo_item["qbo_product_type"]=='Inventory' || $qbo_item["qbo_product_type"]=='InventoryAssembly')){
								$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
								if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
									if($this->is_inv_site_bin_allowed()){
										if (strpos($mw_wc_qbo_desk_compt_qbd_invt_site_ref, ':') !== false) {
											$site_bin_arr = explode(':',$mw_wc_qbo_desk_compt_qbd_invt_site_ref);											
											if(is_array($site_bin_arr) && !empty($site_bin_arr)){
												$InvoiceLine->set('InventorySiteRef ListID' , $site_bin_arr[0]);
												if(isset($site_bin_arr[1])){
													$InvoiceLine->set('InventorySiteLocationRef ListID' , $site_bin_arr[1]);
												}
											}
										}
									}else{
										$InvoiceLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
									}									
								}
							}

							$Invoice->addInvoiceLine($InvoiceLine);
						}
					}
					
					//pgdf compatibility
					if($this->get_wc_fee_plugin_check()){
						$dc_gt_fees = (isset($invoice_data['dc_gt_fees']))?$invoice_data['dc_gt_fees']:array();
						if(is_array($dc_gt_fees) && count($dc_gt_fees)){
							foreach($dc_gt_fees as $df){
								$InvoiceLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
								
								$UnitPrice = $df['_line_total'];
								$Qty = 1;
								$Amount = $Qty*$UnitPrice;
								
								$df_ItemRef = $this->get_wc_fee_qbo_product($df['name'],'',$invoice_data);
								$InvoiceLine->setItemListID($df_ItemRef);
								
								$InvoiceLine->setRate($UnitPrice);
								$InvoiceLine->setQuantity($Qty);
								$InvoiceLine->setAmount($Amount);
								
								$InvoiceLine->setDesc($df['name']);
								
								$_line_tax = $df['_line_tax'];
								if($_line_tax && $qbo_is_sales_tax){
									$is_tax_applied = true;
									if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')== 'Sales_Tax_Codes'){
										$TaxCodeRef =$qbo_tax_code;
									}else{
										$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
									}
									
									if($TaxCodeRef!=''){
										$InvoiceLine->setSalesTaxCodeListID($TaxCodeRef);
									}
								}else{
									$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
									$InvoiceLine->setSalesTaxCodeListID($zero_rated_tax_code);
								}
								
								/*
								if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync') && ($qbo_item["qbo_product_type"]=='Inventory' || $qbo_item["qbo_product_type"]=='InventoryAssembly')){
									$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
									if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
										$InvoiceLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
									}
								}
								*/
								
								$Invoice->addInvoiceLine($InvoiceLine);
							}
							
						}						
					}
					
					/*Add Invoice Coupons*/
					$used_coupons  = (isset($invoice_data['used_coupons']))?$invoice_data['used_coupons']:array();
					$qbo_is_discount_allowed = true;
					if($this->option_checked('mw_wc_qbo_desk_no_ad_discount_li')){
						$qbo_is_discount_allowed = false;
					}
					
					if($qbo_is_discount_allowed && count($used_coupons)){
						foreach($used_coupons as $coupon){
							$coupon_name = $coupon['name'];
							$coupon_discount_amount = $coupon['discount_amount'];
							$coupon_discount_amount = -1 * abs($coupon_discount_amount);
							$coupon_discount_amount_tax = $coupon['discount_amount_tax'];
							
							if($this->wacs_base_cur_enabled()){
								$coupon_discount_amount_base_currency = $this->get_array_isset($coupon,'discount_amount_base_currency',0);
								$coupon_discount_amount_base_currency = -1 * abs($coupon_discount_amount_base_currency);
								
								$coupon_discount_amount_tax_base_currency = $coupon['discount_amount_tax_base_currency'];
							}

							$coupon_product_arr = $this->get_mapped_coupon_product($coupon_name);
							$DiscountLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
							$DiscountLine->setItemListID($coupon_product_arr["ItemRef"]);
							if(isset($coupon_product_arr["ClassRef"]) && $coupon_product_arr["ClassRef"]!=''){
								$DiscountLine->setClassListID($coupon_product_arr["ClassRef"]);
							}
							$Description = $coupon_product_arr['Description'];							
							
							if($this->wacs_base_cur_enabled()){
								$Description.= " ({$_order_currency} {$coupon_discount_amount})";
								$DiscountLine->setRate($coupon_discount_amount_base_currency);
								if($coupon_product_arr['qbo_product_type'] != 'Discount'){
									$DiscountLine->setAmount($coupon_discount_amount_base_currency);
								}																
							}else{
								$DiscountLine->setRate($coupon_discount_amount);
								if($coupon_product_arr['qbo_product_type'] != 'Discount'){
									$DiscountLine->setAmount($coupon_discount_amount);
								}								
							}
							
							if($coupon_product_arr['qbo_product_type'] != 'Discount'){
								$DiscountLine->setQuantity(1);
							}							
							$DiscountLine->setDesc($Description);
							
							if($qbo_is_sales_tax){
								if($coupon_discount_amount_tax > 0 || $is_tax_applied){
									if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')== 'Sales_Tax_Codes'){
										$TaxCodeRef =$qbo_tax_code;
									}else{
										$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
									}
									
									if($TaxCodeRef!=''){
										$DiscountLine->setSalesTaxCodeListID($TaxCodeRef);
									}
								}else{
									$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
									$DiscountLine->setSalesTaxCodeListID($zero_rated_tax_code);
								}								
							}
							
							if(!$qbo_is_sales_tax){
								$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
								$DiscountLine->setSalesTaxCodeListID($zero_rated_tax_code);
							}
							
							if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync')){
								$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
								if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
									//$DiscountLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
								}
							}
							
							$Invoice->addInvoiceLine($DiscountLine);
						}
					}					
					
					/*Add Invoice Shipping*/
					$shipping_details  = (isset($invoice_data['shipping_details']))?$invoice_data['shipping_details']:array();
					
					if(is_array($shipping_details) && !empty($shipping_details)){
						foreach($shipping_details as $sd_k => $sd_v){
							
							$shipping_method = '';
							$shipping_method_name = '';
							$shipping_taxes = '';
							$smt_id = 0;
							
							if(isset($shipping_details[$sd_k])){
								if($this->get_array_isset($shipping_details[$sd_k],'type','')=='shipping'){
									$shipping_method_id = $this->get_array_isset($shipping_details[$sd_k],'method_id','');
									if($shipping_method_id!=''){
										if(isset($shipping_details[$sd_k]['instance_id']) && $shipping_details[$sd_k]['instance_id']>0){
											$shipping_method = $this->get_array_isset($shipping_details[$sd_k],'method_id','');
											$smt_id = (int) $this->get_array_isset($shipping_details[$sd_k],'instance_id',0);
										}else{
											$shipping_method = $this->wc_get_sm_data_from_method_id_str($shipping_method_id);
											$smt_id = $this->wc_get_sm_data_from_method_id_str($shipping_method_id,'id');
										}								
									}
									
									$shipping_method = ($shipping_method=='')?'no_method_found':$shipping_method;
									$shipping_method_name =  $this->get_array_isset($shipping_details[$sd_k],'name','',true,30);
									$shipping_taxes = $this->get_array_isset($shipping_details[$sd_k],'taxes','');
								}
							}										
							
							$shipping_product_arr = array();
							
							if($shipping_method!=''){
								if(!$qbo_is_shipping_allowed){
									if($smt_id>0){
										$smt_id_str = $shipping_method.':'.$smt_id;
										$shipping_product_arr = $this->get_mapped_shipping_product($smt_id_str);
									}
									
									if(!count($shipping_product_arr) || empty($shipping_product_arr['ItemRef'])){
										$shipping_product_arr = $this->get_mapped_shipping_product($shipping_method);
									}
									
									$ShippingLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
									$ShippingLine->setItemListID($shipping_product_arr["ItemRef"]);
									if(isset($shipping_product_arr["ClassRef"]) && $shipping_product_arr["ClassRef"]!=''){
										$ShippingLine->setClassListID($shipping_product_arr["ClassRef"]);
									}
									$shipping_description = ($shipping_method_name!='')?'Shipping ('.$shipping_method_name.')':'Shipping';							
									if(!$this->check_sh_wcmslscqb_hash()){
										if($this->wacs_base_cur_enabled()){
											$shipping_description.= " ({$_order_currency} {$order_shipping_total})";
											$ShippingLine->setRate($order_shipping_total_base_currency);
											$ShippingLine->setAmount($order_shipping_total_base_currency);
										}else{
											$ShippingLine->setRate($order_shipping_total);								
											$ShippingLine->setAmount($order_shipping_total);
										}
									}else{
										$ShippingLine->setRate($sd_v['cost']);						
										$ShippingLine->setAmount($sd_v['cost']);
									}									
									
									//$ShippingLine->setQuantity(1);
									if(!$this->option_checked('mw_wc_qbo_desk_skip_os_lid')){
										$ShippingLine->setDesc($shipping_description);
									}
									
									if($qbo_is_sales_tax){
										if(($this->check_sh_wcmslscqb_hash() && $sd_v['total_tax']>0) || (!$this->check_sh_wcmslscqb_hash() && $_order_shipping_tax>0)){
											$TaxCodeRef = '';
											if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')== 'Sales_Tax_Codes'){
												$TaxCodeRef =$qbo_tax_code;
											}
											
											if($this->is_plugin_active('myworks-quickbooks-desktop-shipping-tax-compt') && $this->check_sh_stc_hash()){
												$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_shipping_tax_rule_taxable');
											}
											if(empty($TaxCodeRef)){
												$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
											}
											
											if($TaxCodeRef!=''){
												$ShippingLine->setSalesTaxCodeListID($TaxCodeRef);
											}
										}else{
											if($this->is_plugin_active('myworks-quickbooks-desktop-shipping-tax-compt') && $this->check_sh_stc_hash()){
												$zero_rated_tax_code = $this->get_option('mw_wc_qbo_desk_shipping_tax_rule_taxable');
											}else{
												$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
											}
											$ShippingLine->setSalesTaxCodeListID($zero_rated_tax_code);
										}
									}
									
									if(!$qbo_is_sales_tax){
										if($this->is_plugin_active('myworks-quickbooks-desktop-shipping-tax-compt') && $this->check_sh_stc_hash()){
											$zero_rated_tax_code = $this->get_option('mw_wc_qbo_desk_shipping_tax_rule_taxable');
										}else{
											$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
										}
										$ShippingLine->setSalesTaxCodeListID($zero_rated_tax_code);
									}
									
									if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync')){
										$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
										if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
											//$ShippingLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
										}
									}

									$Invoice->addInvoiceLine($ShippingLine);

								}
							}
							
							if(!$this->check_sh_wcmslscqb_hash()){
								break;
							}
						}
					}

					if(!$is_taxjar_active){
						//$order_shipping_total+=$_order_shipping_tax;
						if($this->wacs_base_cur_enabled()){
							//$order_shipping_total_base_currency+=$_order_shipping_tax_base_currency;
						}
					}
					
					//TaxJar Line
					if($is_taxjar_active && count($tax_details) && $_order_total_tax >0){
						$ExtLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
						$taxjar_item = $this->get_option('mw_wc_qbo_desk_wc_taxjar_map_qbo_product');
						if(empty($taxjar_item)){
							$taxjar_item = $this->get_option('mw_wc_qbo_desk_default_qbo_item');
						}
						
						$ExtLine->setItemListID($taxjar_item);
						$Description = 'TaxJar - QBD Line Item';
						
						if($this->wacs_base_cur_enabled()){
							$Description.= " ({$_order_currency} {$_order_total_tax})";
							//$ExtLine->setRate($_order_tax_base_currency);
							$ExtLine->setAmount($_order_total_tax_base_currency);
						}else{
							//$ExtLine->setRate($_order_tax);
							$ExtLine->setAmount($_order_total_tax);
						}
						
						//$ExtLine->setQuantity(1);
						$ExtLine->setDesc($Description);
						
						if(!$qbo_is_sales_tax){
							$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
							$ExtLine->setSalesTaxCodeListID($zero_rated_tax_code);
						}
						
						if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync')){
							$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
							if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
								//$ExtLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
							}
						}

						$Invoice->addInvoiceLine($ExtLine);
					}
					
					//Avatax Line
					if($is_avatax_active && count($tax_details) && $_order_total_tax >0){
						$ExtLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
						$avatax_item = $this->get_option('mw_wc_qbo_desk_wc_avatax_map_qbo_product');
						if(empty($avatax_item)){
							$avatax_item = $this->get_option('mw_wc_qbo_desk_default_qbo_item');
						}
						
						$ExtLine->setItemListID($avatax_item);
						$Description = 'Avatax - QBD Line Item';				
						
						if($this->wacs_base_cur_enabled()){
							$Description.= " ({$_order_currency} {$_order_total_tax})";
							//$ExtLine->setRate($_order_tax_base_currency);
							$ExtLine->setAmount($_order_total_tax_base_currency);
						}else{
							//$ExtLine->setRate($_order_tax);
							$ExtLine->setAmount($_order_total_tax);
						}
						
						//$ExtLine->setQuantity(1);
						
						$ExtLine->setDesc($Description);
						
						if(!$qbo_is_sales_tax){
							$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
							//$ExtLine->setSalesTaxCodeListID($zero_rated_tax_code);
						}
						
						if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync')){
							$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
							if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
								//$ExtLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
							}
						}

						$Invoice->addInvoiceLine($ExtLine);
					}
					
					//Order Tax as Line Item					
					if($is_so_tax_as_li && count($tax_details) && $_order_total_tax >0){
						$ExtLine = new QuickBooks_QBXML_Object_Invoice_InvoiceLine();
						$otli_item = $this->get_option('mw_wc_qbo_desk_otli_qbd_product');
						if(empty($otli_item)){
							$otli_item = $this->get_option('mw_wc_qbo_desk_default_qbo_item');
						}
						
						$ExtLine->setItemListID($otli_item);
						
						$Description = '';
						if(is_array($tax_details) && count($tax_details)){
							if(isset($tax_details[0]['label'])){
								$Description = $tax_details[0]['label'];
							}
							
							if(isset($tax_details[1]) && $tax_details[1]['label']){
								if(!empty(tax_details[1]['label'])){
									$Description = $Description.', '.$tax_details[1]['label'];
								}
							}
						}
						
						if(empty($Description)){
							$Description = 'Woocommerce Order Tax - QBD Line Item';
						}
						
						if($this->wacs_base_cur_enabled()){
							$Description.= " ({$_order_currency} {$_order_total_tax})";
							//$ExtLine->setRate($_order_tax_base_currency);
							$ExtLine->setAmount($_order_total_tax_base_currency);
						}else{
							//$ExtLine->setRate($_order_tax);
							$ExtLine->setAmount($_order_total_tax);
						}
						
						//$ExtLine->setQuantity(1);
						
						$ExtLine->setDesc($Description);
						
						if(!$qbo_is_sales_tax){
							$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
							//$ExtLine->setSalesTaxCodeListID($zero_rated_tax_code);
						}
						
						if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync')){
							$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
							if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
								//$ExtLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
							}
						}

						$Invoice->addInvoiceLine($ExtLine);
					}
					
					//
					if($is_tax_applied){
						$TaxCodeRef =$qbo_tax_code;
						if($TaxCodeRef!=''){
							if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')!= 'Sales_Tax_Codes'){
								$Invoice->setSalesTaxItemListID($TaxCodeRef);
							}							
						}
					}					
					
					//31-10-2017
					$is_as_addr_format = true;
					

					$billing_name = $this->get_array_isset($invoice_data,'_billing_first_name','',true).' '.$this->get_array_isset($invoice_data,'_billing_last_name','',true);
					$billing_name_fl = $billing_name;

					$country = $this->get_array_isset($invoice_data,'_billing_country','',true);
					$country = $this->get_country_name_from_code($country);
					//$country = '';
					
					$_billing_company = $this->get_array_isset($invoice_data,'_billing_company','',true);
					$_billing_address_1 = $this->get_array_isset($invoice_data,'_billing_address_1','',true);
					$_billing_address_2 = $this->get_array_isset($invoice_data,'_billing_address_2','',true);
					$_billing_city = $this->get_array_isset($invoice_data,'_billing_city','',true);
					$_billing_state = $this->get_array_isset($invoice_data,'_billing_state','',true);
					$_billing_postcode = $this->get_array_isset($invoice_data,'_billing_postcode','',true);
					
					$_billing_phone = $this->get_array_isset($invoice_data,'_billing_phone','',true);
					
					/**/
					$skip_billing_address = false;
					if($this->option_checked('mw_wc_qbo_desk_use_qb_ba_for_eqc') && is_array($extra) && isset($extra['existing_qbo_user_id']) && !empty($extra['existing_qbo_user_id'])){
						$skip_billing_address = true;
					}
					
					if(!$skip_billing_address){
						if(!$is_as_addr_format){
							if($_billing_company!=''){
								$Invoice->setBillAddress(
									$billing_name,$_billing_company,$_billing_address_1,$_billing_address_2,'',$_billing_city,$_billing_state,'',$_billing_postcode,
									$country
								);
							}else{
								$Invoice->setBillAddress(
									$billing_name,$_billing_address_1,$_billing_address_2,'','',$_billing_city,$_billing_state,'',$_billing_postcode,
									$country
								);
							}
						}else{
							$rfs_arr = array($this->get_array_isset($invoice_data,'_billing_first_name','',true),$this->get_array_isset($invoice_data,'_billing_last_name','',true),$_billing_company,$_billing_address_1,$_billing_address_2,$_billing_city,$_billing_state,$_billing_postcode,$_billing_phone,$country);
							$r_fa = $this->get_ord_baf_addrs($rfs_arr);
							$Invoice->setBillAddress(
								$this->get_array_isset($r_fa,0,'',true),
								$this->get_array_isset($r_fa,1,'',true),
								$this->get_array_isset($r_fa,2,'',true),
								$this->get_array_isset($r_fa,3,'',true),
								$this->get_array_isset($r_fa,4,'',true)
								
							);
						}
					}					

					if($this->get_array_isset($invoice_data,'_shipping_first_name','',true)!=''){
						$shipping_name = $this->get_array_isset($invoice_data,'_shipping_first_name','',true).' '.$this->get_array_isset($invoice_data,'_shipping_last_name','',true);

						$country = $this->get_array_isset($invoice_data,'_shipping_country','',true);
						$country = $this->get_country_name_from_code($country);
						
						$_shipping_company = $this->get_array_isset($invoice_data,'_shipping_company','',true);
						$_shipping_address_1 = $this->get_array_isset($invoice_data,'_shipping_address_1','',true);
						$_shipping_address_2 = $this->get_array_isset($invoice_data,'_shipping_address_2','',true);
						$_shipping_city = $this->get_array_isset($invoice_data,'_shipping_city','',true);
						$_shipping_state = $this->get_array_isset($invoice_data,'_shipping_state','',true);
						$_shipping_postcode = $this->get_array_isset($invoice_data,'_shipping_postcode','',true);
						
						if(!$is_as_addr_format){
							if($_shipping_company!=''){
								$Invoice->setShipAddress(
									$shipping_name,$_shipping_company,$_shipping_address_1,$_shipping_address_2,'',$_shipping_city,$_shipping_state,'',$_shipping_postcode,
									$country
								);
							}else{
								$Invoice->setShipAddress(
									$shipping_name,$_shipping_address_1,$_shipping_address_2,'','',$_shipping_city,$_shipping_state,'',$_shipping_postcode,
									$country
								);
							}
						}else{
							$rfs_arr = array($this->get_array_isset($invoice_data,'_shipping_first_name','',true),$this->get_array_isset($invoice_data,'_shipping_last_name','',true),$_shipping_company,$_shipping_address_1,$_shipping_address_2,$_shipping_city,$_shipping_state,$_shipping_postcode,$country);
							$r_fa = $this->get_ord_saf_addrs($rfs_arr);
							$Invoice->setShipAddress(
								$this->get_array_isset($r_fa,0,'',true),
								$this->get_array_isset($r_fa,1,'',true),
								$this->get_array_isset($r_fa,2,'',true),
								$this->get_array_isset($r_fa,3,'',true),
								$this->get_array_isset($r_fa,4,'',true)
								
							);
						}						
						
					}
					
					/*
					setShipAddress($addr1, $addr2 = '', $addr3 = '', $addr4 = '', $addr5 = '', $city = '', $state = '', $province = '', $postalcode = '', $country = '', $note = '')
					*/

					/*
					setBillAddress($addr1, $addr2 = '', $addr3 = '', $addr4 = '', $addr5 = '', $city = '', $state = '', $province = '', $postalcode = '', $country = '', $note = '')
					*/

					/*
					setShipMethodName
					setShipMethodListID
					setShipDate

					setPaymentMethodName
					setPaymentMethodListID
					
					setPONumber
					setSalesRepListID

					*/

					$Q_Memo = '';
					$customer_note = $this->get_array_isset($invoice_data,'customer_note','');
					if($this->option_checked('mw_wc_qbo_desk_invoice_memo')){
						$Q_Memo = $customer_note;
					}
					
					if($this->option_checked('mw_wc_qbo_desk_cname_into_memo')){
						$cname_memo = $billing_name_fl;
						$Q_Memo = $cname_memo;
					}
					
					$Q_Memo = trim($Q_Memo);
					if($this->option_checked('mw_wc_qbo_desk_use_qb_in_sr_so_ref_num')){
						if(!empty($Q_Memo)){
							$Q_Memo.= PHP_EOL . 'Order: '. $DocNumber;
						}else{
							$Q_Memo = 'Order: '. $DocNumber;
						}						
					}
					
					$Invoice->setMemo($Q_Memo);
					
					//New - Extra Fields
					$mw_wc_qbo_desk_ord_push_rep_othername = $this->get_option('mw_wc_qbo_desk_ord_push_rep_othername');
					if($mw_wc_qbo_desk_ord_push_rep_othername!=''){
						$Invoice->setSalesRepListID($mw_wc_qbo_desk_ord_push_rep_othername);
					}
					
					//WWLC CF SalesRep QBD SalesRep Map
					if($wc_cus_id>0 && $this->is_plugin_active('woocommerce-wholesale-lead-capture','woocommerce-wholesale-lead-capture.bootstrap') && $this->option_checked('mw_wc_qbo_desk_compt_wwlc_rf_srm_ed')){
						$wwlc_cf_rep_map = get_option('mw_wc_qbo_desk_wwlc_cf_rep_map');
						if(is_array($wwlc_cf_rep_map) && count($wwlc_cf_rep_map)){
							$wwlc_cf_rep = get_user_meta($wc_cus_id,'wwlc_cf_rep',true);
							if(!empty($wwlc_cf_rep)){
								if(isset($wwlc_cf_rep_map[$wwlc_cf_rep]) && !empty($wwlc_cf_rep_map[$wwlc_cf_rep])){
									$qbd_salesrep_id = $wwlc_cf_rep_map[$wwlc_cf_rep];
									$Invoice->setSalesRepListID($qbd_salesrep_id);
								}
							}
						}
					}
					
					//WCFE CF SalesRep QBD SalesRep Map
					if($this->is_plugin_active('woocommerce-checkout-field-editor') && $this->option_checked('mw_wc_qbo_desk_compt_wcfe_rf_srm_ed')){
						$wcfe_cf_rep_map = get_option('mw_wc_qbo_desk_wcfe_cf_rep_map');
						if(is_array($wcfe_cf_rep_map) && count($wcfe_cf_rep_map)){
							$wcfe_cf_rep = $this->get_array_isset($invoice_data,'sales-rep','');
							if(!empty($wcfe_cf_rep)){
								if(isset($wcfe_cf_rep_map[$wcfe_cf_rep]) && !empty($wcfe_cf_rep_map[$wcfe_cf_rep])){
									$qbd_salesrep_id = $wcfe_cf_rep_map[$wcfe_cf_rep];
									$Invoice->setSalesRepListID($qbd_salesrep_id);
								}
							}
						}
					}
					
					if($this->is_plugin_active('woocommerce-gateway-purchase-order') && $this->option_checked('mw_wc_qbo_desk_wpopg_po_support')){
						//if($_payment_method == 'woocommerce_gateway_purchase_order'){}
						$_po_number = $this->get_array_isset($invoice_data,'_po_number','',true);
						if($_po_number!=''){
							$Invoice->setPONumber($_po_number);
						}else{
							$Invoice->setPONumber('Web');
						}
					}
					
					$mw_wc_qbo_desk_ord_push_entered_by = $this->get_option('mw_wc_qbo_desk_ord_push_entered_by');
					if($mw_wc_qbo_desk_ord_push_entered_by!=''){
						$Invoice->setOther($mw_wc_qbo_desk_ord_push_entered_by);
					}
					
					
					if($this->wacs_base_cur_enabled()){					
						$base_currency = get_woocommerce_currency();
						$pm_map_data = $this->get_mapped_payment_method_data($_payment_method,$base_currency);
					}else{
						$pm_map_data = $this->get_mapped_payment_method_data($_payment_method,$_order_currency);
					}

					$term_id_str = $this->get_array_isset($pm_map_data,'term_id_str','',true);
					if($term_id_str!=''){
						$Invoice->set('TermsRef ListID',$term_id_str);
					}
					
					$qb_p_method_id = $this->get_array_isset($pm_map_data,'qb_p_method_id','',true);
					if($qb_p_method_id!=''){
						$Invoice->set('PaymentMethodRef ListID',$qb_p_method_id);
					}
					//$this->_p($shipping_product_arr);
					if(count($shipping_product_arr)){
						$qb_shipmethod_id = $this->get_array_isset($shipping_product_arr,'qb_shipmethod_id','',true);
						if($qb_shipmethod_id!=''){
							$Invoice->set('ShipMethodRef ListID',$qb_shipmethod_id);
						}
					}
					
					/**/
					if($this->is_plugin_active('myworks-quickbooks-desktop-sj-custom-shipping-field-mapping') && $this->check_sh_sj_csfm_hash() && $this->option_checked('mw_wc_qbo_desk_compt_np_sj_ocsf_map')){
						$_carrier_name = $this->get_array_isset($invoice_data,'_carrier_name','',true);
						$mw_wc_qbo_desk_compt_sjocsfm_mv = get_option('mw_wc_qbo_desk_compt_sjocsfm_mv');
						if(!empty($_carrier_name) && is_array($mw_wc_qbo_desk_compt_sjocsfm_mv) && isset($mw_wc_qbo_desk_compt_sjocsfm_mv[$_carrier_name])){
							$sj_cn_qb_sm_id = $mw_wc_qbo_desk_compt_sjocsfm_mv[$_carrier_name];
							if(!empty($sj_cn_qb_sm_id)){
								$Invoice->set('ShipMethodRef ListID',$sj_cn_qb_sm_id);
							}
						}
					}
					
					$cf_map_data = array();
					if($this->is_plugin_active('myworks-quickbooks-desktop-custom-field-mapping') && $this->check_sh_cfm_hash()){
						$cf_map_data = $this->get_cf_map_data();
					}
					
					if(is_array($cf_map_data) && count($cf_map_data)){
						$qacfm = $this->get_qbo_avl_cf_map_fields();
						foreach($cf_map_data as $wcfm_k => $wcfm_v){
							$wcfm_k = trim($wcfm_k);
							$wcfm_v = trim($wcfm_v);
							
							if(!empty($wcfm_v)){
								$wcf_val = '';
								switch ($wcfm_k) {									
									case "wc_order_shipping_method_name":
										$wcf_val = $shipping_method_name;
										break;
									case "wc_order_phone_number":
										$wcf_val = $this->get_array_isset($invoice_data,'_billing_phone','',true);
										break;
									default:
										if(isset($invoice_data[$wcfm_k])){
											//is_string
											if(!is_array($invoice_data[$wcfm_k]) && !is_object($invoice_data[$wcfm_k])){
												$wcf_val = $this->get_array_isset($invoice_data,$wcfm_k,'',true);
											}										
										}
								}
								
								if(!empty($wcf_val) && isset($qacfm[$wcfm_v])){
									$qbo_cf_arr = array();
									switch ($wcfm_v) {
										case "":								
											break;
											
										default:
										try {
											if(is_array($qbo_cf_arr) && count($qbo_cf_arr) && isset($qbo_cf_arr[$wcfm_v])){
												//
											}else{
												$qacfm_naf = $this->get_qbo_avl_cf_map_fields(true);
												$ivqf = true;
												if(is_array($qacfm_naf) && count($qacfm_naf) && isset($qacfm_naf[$wcfm_v])){
													$ivqf = false;
												}
												if($ivqf){
													$Invoice->set("{$wcfm_v}",$wcf_val);
												}
											}
										}catch(Exception $e) {
											$cfm_err = $e->getMessage();
										}
									}
								}
							}
						}
					}
					
					//
					$exchange_rate = '';					
					if(!empty($_order_currency) && isset($invoice_data['_woocs_order_base_currency']) && $invoice_data['_woocs_order_base_currency'] == $_order_currency){
						//$exchange_rate = 1.82;
					}					
					
					//$this->_p($Invoice);
					
					$qbxml = $Invoice->asQBXML(QUICKBOOKS_ADD_INVOICE,null,$this->get_qbxml_locale());					
					$qbxml = $this->get_qbxml_prefix().$qbxml. $this->get_qbxml_suffix();
					
					if($exchange_rate != ''){
						$qbxml = str_replace('</TxnDate>','</TxnDate>'. PHP_EOL .'		<ExchangeRate>1.82</ExchangeRate>',$qbxml);
					}			
					
					return $qbxml;

				}
			}
		}
	}
	
	public function format_xml($xml){
		$xml = trim($xml);		
		if(!empty($xml)){
			$dom = new DOMDocument;
			$dom->preserveWhiteSpace = FALSE;
			$dom->loadXML($xml);
			$dom->formatOutput = TRUE;
			$xml = $dom->saveXml();
		}
		return $xml;
	}
	
	/**/
	public function GetOrderDataExtAddQbxml($order_id,$extra){
		if($this->is_qwc_connected()){
			$order_id = intval($order_id);
			if(!$this->ord_pmnt_is_mt_ls_check_by_ord_id($order_id)){
				return false;
			}
			
			$qbxml = '';
			if($order_id>0 && is_array($extra) && !empty($extra) && isset($extra['Qos_Type']) && !empty($extra['Qos_Type'])){
				if(isset($extra['TxnID']) && !empty($extra['TxnID'])){
					$order = get_post($order_id);
					$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
					if(is_array($invoice_data) && count($invoice_data)){
						if($this->check_cf_map_data_ext_field_value_exists($order_id,$extra['Qos_Type'])){
							$cf_map_data = array();
							if($this->is_plugin_active('myworks-quickbooks-desktop-custom-field-mapping') && $this->check_sh_cfm_hash() && $order_id > 0){
								$cf_map_data = $this->get_cf_map_data();
							}
							
							if(is_array($cf_map_data) && !empty($cf_map_data)){
								$qacfm = $this->get_qbo_avl_cf_map_fields();
								if(is_array($qacfm) && !empty($qacfm)){
									foreach($cf_map_data as $wcfm_k => $wcfm_v){
										$wcfm_k = trim($wcfm_k);
										$wcfm_v = trim($wcfm_v);
										
										if(!empty($wcfm_v) && !isset($qacfm[$wcfm_v])){
											$wcf_val = '';
											switch ($wcfm_k) {									
												case "wc_order_shipping_method_name":
													/**/									
													$shipping_method_name = '';									
													$shipping_details  = (isset($invoice_data['shipping_details']))?$invoice_data['shipping_details']:array();
													if(isset($shipping_details[0])){
														if($this->get_array_isset($shipping_details[0],'type','')=='shipping'){
															$shipping_method_name =  $this->get_array_isset($shipping_details[0],'name','',true,30);
														}
													}
													
													$wcf_val = $shipping_method_name;
													break;
												case "wc_order_phone_number":
													$wcf_val = $this->get_array_isset($invoice_data,'_billing_phone','',true);
													break;
												default:
													if(isset($invoice_data[$wcfm_k])){
														//is_string
														if(!is_array($invoice_data[$wcfm_k]) && !is_object($invoice_data[$wcfm_k])){
															$wcf_val = $this->get_array_isset($invoice_data,$wcfm_k,'',true);
														}										
													}
											}
											
											if(!empty($wcf_val)){
												$DataExt = new QuickBooks_QBXML_Object_DataExt();
												$DataExt->setOwnerID($this->get_owner_id());
												$DataExt->setDataExtName($wcfm_v);
												$DataExt->set('DataExtType',$this->qbd_dext_type_str());
												$DataExt->setDataExtValue($wcf_val);
												
												$DataExt->setTxnDataExtType($extra['Qos_Type']);
												$DataExt->setTxnID($extra['TxnID']);
												//$this->_p($DataExt);
												
												$qbxml_tmp = $DataExt->asQBXML(QUICKBOOKS_MOD_DATAEXT,null,$this->get_qbxml_locale());
												/*
												if (strpos($qbxml_tmp, '<DataExtType>') === false) {
													$qbxml_tmp = str_replace('</OwnerID>', '</OwnerID>' .PHP_EOL .'<DataExtType>'.$this->qbd_dext_type_str().'</DataExtType>', $qbxml_tmp);
												}
												*/												
												$qbxml.= $qbxml_tmp;
											}
										}
									}
								}
							}
						}
					}
				}
			}
			
			if(!empty($qbxml)){
				$qbxml = $this->get_qbxml_prefix().$qbxml. $this->get_qbxml_suffix();
			}
			
			return $qbxml;
		}
	}
	
	/*SalesReceipt*/	
	public function GetSalesReceiptQbxml_GPI($order_id){		
		if($this->is_qwc_connected()){
			if(!$this->ord_pmnt_is_mt_ls_check_by_ord_id($order_id)){
				return false;
			}
			
			$order = get_post($order_id);
			$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
			//$this->_p($invoice_data);
			if(is_array($invoice_data) && count($invoice_data)){
				//$q_whr = " AND `qb_status` = 'q' ";
				$q_whr = '';
				$queue_data = $this->get_row("SELECT * FROM `quickbooks_queue` WHERE `qb_action` = 'SalesReceiptMod_GPI' {$q_whr} AND `ident` = {$order_id} ORDER BY `quickbooks_queue_id` DESC");
				
				if(is_array($queue_data) && count($queue_data)){
					$extra = $queue_data['extra'];
					if(!empty($extra)){
						$extra = @unserialize($extra);
						if(is_array($extra) && count($extra)){
							$xml = $queue_data['qbxml'];
							$xml_c = '';
							if(!empty($xml)){
								//echo $xml;
								$errnum = 0;
								$errmsg = '';
								$Parser = new QuickBooks_XML_Parser($xml);
								
								$gp_li_dtls_arr = array();
								$gp_li_dtls_arr_c = array();
								
								$np_li_dtls_arr = array();
								
								if ($Doc = $Parser->parse($errnum, $errmsg)){
									$Root = $Doc->getRoot();
									$List = $Root->getChildAt('QBXML/QBXMLMsgsRs/SalesReceiptAddRs');
									foreach ($List->children() as $Item){										
										$xml_c = $Item->asXML();
										$ret = $Item->name();										
										if(count($Item->children())){
											foreach ($Item->children() as $Item_c){
												$ret_c = $Item_c->name();
												if($ret_c == 'SalesReceiptLineGroupRet'){
													$gp_tmp_arr = array();
													$gp_tmp_arr['TxnLineID'] = $Item_c->getChildDataAt($ret_c . ' TxnLineID');
													$gp_tmp_arr['ItemGroupRef_ListID'] = $Item_c->getChildDataAt($ret_c . ' ItemGroupRef ListID');
													$gp_tmp_arr['TotalAmount'] = $Item_c->getChildDataAt($ret_c . ' TotalAmount');
													$gp_tmp_arr['Quantity'] = $Item_c->getChildDataAt($ret_c . ' Quantity');
													
													$gp_li_dtls_arr[] = $gp_tmp_arr;
													
													$TxnLineID_Gl = $Item_c->getChildDataAt($ret_c . ' TxnLineID');
													if(count($Item_c->children())){
														foreach ($Item_c->children() as $Item_c_c){
															$ret_c_c = $Item_c_c->name();
															if($ret_c_c == 'SalesReceiptLineRet'){
																$gp_tmp_arr_c = array();
																$gp_tmp_arr_c['TxnLineID'] = $Item_c_c->getChildDataAt($ret_c_c . ' TxnLineID');
																$gp_tmp_arr_c['ItemRef_ListID'] = $Item_c_c->getChildDataAt($ret_c_c . ' ItemRef ListID');
																$gp_tmp_arr_c['Quantity'] = $Item_c_c->getChildDataAt($ret_c_c . ' Quantity');
																$gp_tmp_arr_c['Rate'] = $Item_c_c->getChildDataAt($ret_c_c . ' Rate');
																$gp_tmp_arr_c['Amount'] = $Item_c_c->getChildDataAt($ret_c_c . ' Amount');
																
																//
																$gp_tmp_arr_c['InventorySiteRef_ListID'] = $Item_c_c->getChildDataAt($ret_c_c . ' InventorySiteRef ListID');
																
																$gp_tmp_arr_c['SalesTaxCodeRef_ListID'] = $Item_c_c->getChildDataAt($ret_c_c . ' SalesTaxCodeRef ListID');
																
																$gp_li_dtls_arr_c[$TxnLineID_Gl][] = $gp_tmp_arr_c;
																
															}
														}
													}
												}
												
												if($ret_c == 'SalesReceiptLineRet'){
													$np_tmp_arr = array();
													$np_tmp_arr['TxnLineID'] = $Item_c->getChildDataAt($ret_c . ' TxnLineID');
													
													$np_li_dtls_arr[] = $np_tmp_arr;
												}
											}
										}
									}									
								}
								
								//$this->_p($gp_li_dtls_arr);
								//$this->_p($gp_li_dtls_arr_c);
								
								//
								$gi_last_li_data = array();
								$adjust_last_gi_price = false;
								
								$gp_li_pd_arr = array();
								if(is_array($gp_li_dtls_arr) && !empty($gp_li_dtls_arr) && is_array($gp_li_dtls_arr_c) && !empty($gp_li_dtls_arr_c)){
									$qbo_inv_items = (isset($invoice_data['qbo_inv_items']))?$invoice_data['qbo_inv_items']:array();
									if(is_array($qbo_inv_items) && !empty($qbo_inv_items)){
										foreach($qbo_inv_items as $qbo_item){
											if($qbo_item['qbo_product_type'] == 'Group'){
												$UnitPrice = $qbo_item["UnitPrice"];
												$Qty = $qbo_item["Qty"];
												$Amount = $Qty*$UnitPrice;
												
												foreach($gp_li_dtls_arr as $gld){
													if($qbo_item["ItemRef"] == $gld['ItemGroupRef_ListID'] && $Qty == $gld['Quantity']){
														$wc_b_price = $Amount;
														$qbo_b_tp = $gld['TotalAmount'];
														$gp_p_diff = ($wc_b_price-$qbo_b_tp);
														if($gp_p_diff!=0){
															$gp_li_pd_arr[$gld['TxnLineID']] = $gp_p_diff;
														}
													}
												}												
											}											
										}
									}
								}								
								
								if(is_array($gp_li_pd_arr) && count($gp_li_pd_arr)){
									$SalesReceipt = new QuickBooks_QBXML_Object_SalesReceipt();
									$SalesReceipt->set('TxnID',$extra['TxnID']);									
									
									$SalesReceipt->set('EditSequence',$extra['EditSequence']);
									
									if(is_array($np_li_dtls_arr) && !empty($np_li_dtls_arr)){
										foreach($np_li_dtls_arr as $nld){
											$SalesReceiptLine = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLine();
											$SalesReceiptLine->set('TxnLineID',$nld['TxnLineID']);
											$SalesReceipt->addSalesReceiptLine($SalesReceiptLine);
											
										}
									}
									
									foreach($gp_li_dtls_arr as $gld){										
										if(isset($gp_li_dtls_arr_c[$gld['TxnLineID']]) && !empty($gp_li_dtls_arr_c[$gld['TxnLineID']])){
											$SalesReceiptLineGroup = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLineGroup();
											$SalesReceiptLineGroup->set('TxnLineID',$gld['TxnLineID']);
											$gc_lines = array();
											
											$gi_last_key = (count($gp_li_dtls_arr_c[$gld['TxnLineID']]) - 1);
											foreach($gp_li_dtls_arr_c[$gld['TxnLineID']] as $gld_c_k => $gld_c_v){
												$SalesReceiptLine = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLine();
												$SalesReceiptLine->set('TxnLineID',$gld_c_v['TxnLineID']);
												//
												if($gld_c_k == $gi_last_key){													
													$gi_last_li_data['ItemRef_ListID'] = $gld_c_v['ItemRef_ListID'];
													$gi_last_li_data['InventorySiteRef_ListID'] = $gld_c_v['InventorySiteRef_ListID'];
													$gi_last_li_data['SalesTaxCodeRef_ListID'] = $gld_c_v['SalesTaxCodeRef_ListID'];
													
													if($adjust_last_gi_price && isset($gp_li_pd_arr[$gld['TxnLineID']])){
														$gp_p_diff = $gp_li_pd_arr[$gld['TxnLineID']];
														$Quantity = ($gld_c_v['Quantity']!='')?$gld_c_v['Quantity']:0;
														$A_Rate = ($gp_p_diff/$Quantity);
														$A_Rate = $this->qbd_limit_decimal_points($A_Rate);
														
														$N_Rate = ($gld_c_v['Rate']+$A_Rate);
														$N_Amount = $N_Rate*$Quantity;
														
														$SalesReceiptLine->setItemListID($gld_c_v['ItemRef_ListID']);
														$SalesReceiptLine->setRate($N_Rate);
														$SalesReceiptLine->setQuantity($Quantity);
														$SalesReceiptLine->setAmount($N_Amount);
														
														if(!empty($gld_c_v['InventorySiteRef_ListID'])){
															$SalesReceiptLine->set('InventorySiteRef ListID',$gld_c_v['InventorySiteRef_ListID']);
														}
														
														if(!empty($gld_c_v['SalesTaxCodeRef_ListID'])){
															$SalesReceiptLine->set('SalesTaxCodeRef ListID',$gld_c_v['SalesTaxCodeRef_ListID']);
														}
													}
												}
												
												$gc_lines[] = $SalesReceiptLine;												
											}
											
											//
											if(!$adjust_last_gi_price && isset($gp_li_pd_arr[$gld['TxnLineID']])){
												$gp_p_diff = $gp_li_pd_arr[$gld['TxnLineID']];
												$SalesReceiptLine = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLine();
												//
												//$SalesReceiptLine->set('TxnLineID','0');
												
												$gp_pa_item = $this->get_option('mw_wc_qbo_desk_default_qbo_item');
												if(isset($gi_last_li_data['ItemRef_ListID'])){
													//$gp_pa_item = $gi_last_li_data['ItemRef_ListID'];
												}
												
												$SalesReceiptLine->setItemListID($gp_pa_item);
												$SalesReceiptLine->setDesc('Group Product Price Adjustment');
												
												$SalesReceiptLine->setQuantity(1);
												$SalesReceiptLine->setRate($gp_p_diff);
												
												$SalesReceiptLine->setAmount($gp_p_diff);
												
												if(isset($gi_last_li_data['InventorySiteRef_ListID'])){
													//$SalesReceiptLine->set('InventorySiteRef ListID',$gi_last_li_data['InventorySiteRef_ListID']);
												}
												
												if(isset($gi_last_li_data['SalesTaxCodeRef_ListID'])){
													//$SalesReceiptLine->set('SalesTaxCodeRef ListID',$gi_last_li_data['SalesTaxCodeRef_ListID']);
												}
												
												$gc_lines[] = $SalesReceiptLine;
												
											}
											
											//$gc_lines = $SalesReceiptLineGroup->get('SalesReceiptLine');
											//$SalesReceiptLineGroup->set('SalesReceiptLine',$gc_lines);
											$SalesReceiptLineGroup->set('SalesReceiptLineMod',$gc_lines);
											$SalesReceipt->addSalesReceiptLineGroup($SalesReceiptLineGroup);
										}
									}
									
									/*
									if(!empty($xml_c)){
										$Object = QuickBooks_QBXML_Object::fromQBXML($xml_c, QUICKBOOKS_OBJECT_SALESRECEIPT);
										$this->_p($Object);
									}
									*/
									
									//$this->_p($SalesReceipt);
									$qbxml = $SalesReceipt->asQBXML(QUICKBOOKS_MOD_SALESRECEIPT,null,$this->get_qbxml_locale());
									$qbxml = $this->get_qbxml_prefix().$qbxml. $this->get_qbxml_suffix();
									//
									if(!empty($qbxml)){										
										$qbxml = $this->sr_gpi_pxml($qbxml);
									}
									
									return $qbxml;
								}
							}							
						}
					}					
				}				
			}
		}
	}
	
	private function sr_gpi_pxml($xml){
		$search = array('<SalesReceiptLine>', '</SalesReceiptLine>');
		$replace = array('<SalesReceiptLineMod>', '</SalesReceiptLineMod>');
		$xml = str_replace($search, $replace, $xml);
		return $xml;
	}
	
	public function GetSalesReceiptQbxml($order_id,$extra=null){
		if($this->is_qwc_connected()){
			if(!$this->ord_pmnt_is_mt_ls_check_by_ord_id($order_id)){
				return false;
			}
			
			$order = get_post($order_id);
			$invoice_data = $this->get_wc_order_details_from_order($order_id,$order);
			//$this->add_test_log(print_r($invoice_data,true));
			//$this->_p($invoice_data);
	
			if(is_array($invoice_data) && count($invoice_data)){
				global $wpdb;
				$wc_cus_id = (int) $this->get_array_isset($invoice_data,'wc_cus_id',0);
				$qbo_cus_id = '';

				$wc_inv_id = (int) $this->get_array_isset($invoice_data,'wc_inv_id',0);
				$wc_inv_num = $this->get_array_isset($invoice_data,'wc_inv_num','');
				
				$_order_currency = $this->get_array_isset($invoice_data,'_order_currency','',true);				
				
				if($this->is_plugin_active('woocommerce-aelia-currencyswitcher') && $this->option_checked('mw_wc_qbo_desk_wacs_satoc_cb')){				
					if($_order_currency!=''){
						$aelia_cur_cus_map = get_option('mw_wc_qbo_desk_wacs_satoc_map_cur_cus');
						if(is_array($aelia_cur_cus_map) && count($aelia_cur_cus_map)){
							if(isset($aelia_cur_cus_map[$_order_currency]) && trim($aelia_cur_cus_map[$_order_currency])!=''){
								$qbo_cus_id = trim($aelia_cur_cus_map[$_order_currency]);
							}
						}
					}					
				}
				
				/**/
				if($this->is_plugin_active('myworks-quickbooks-desktop-sync-compatibility') && $this->is_plugin_active('myworks-quickbooks-desktop-shipping-us-state-quickbooks-customer-map-compt') && $this->option_checked('mw_wc_qbo_desk_compt_sus_qb_cus_map_ed')){					
					if($wc_cus_id>0){						
						$shipping_country = get_user_meta($wc_cus_id,'shipping_country',true);						
					}else{						
						//$shipping_country = get_post_meta($wc_inv_id,'_shipping_country',true);
						$shipping_country = $this->get_array_isset($invoice_data,'_shipping_country','');
					}
					
					if($shipping_country == 'US'){
						if($wc_cus_id>0){
							$shipping_state = get_user_meta($wc_cus_id,'shipping_state',true);
						}else{
							//$shipping_state = get_post_meta($wc_inv_id,'_shipping_state',true);
							$shipping_state = $this->get_array_isset($invoice_data,'_shipping_state','');
						}
						
						if($shipping_state!=''){
							$sus_qb_cus_map = get_option('mw_wc_qbo_desk_ship_us_st_qb_cus_map');
							if(is_array($sus_qb_cus_map) && count($sus_qb_cus_map)){
								if(isset($sus_qb_cus_map[$shipping_state]) && trim($sus_qb_cus_map[$shipping_state])!=''){
									$qbo_cus_id = trim($sus_qb_cus_map[$shipping_state]);
								}
							}
						}
					}else{
						$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_sus_fb_qb_cus_foc');
					}
				}
				
				if(empty($qbo_cus_id)){
					if(!$this->option_checked('mw_wc_qbo_desk_all_order_to_customer')){
						if($wc_cus_id>0){
							//$qbo_cus_id = $this->get_wc_data_pair_val('Customer',$wc_cus_id);
							if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
								$customer_data = $this->get_wc_customer_info_from_order($order_id);
							}else{
								$customer_data = $this->get_wc_customer_info($wc_cus_id);
							}
							
							$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
						}else{
							$customer_data = $this->get_wc_customer_info_from_order($order_id);
							$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
						}
					}else{
						/*
						if($wc_cus_id>0){
							$user_info = get_userdata($wc_cus_id);
							$io_cs = false;
							if(isset($user_info->roles) && is_array($user_info->roles)){
								$sc_roles_as_cus = $this->get_option('mw_wc_qbo_desk_wc_cust_role_sync_as_cus');
								if(!empty($sc_roles_as_cus)){
									$sc_roles_as_cus = explode(',',$sc_roles_as_cus);
									if(is_array($sc_roles_as_cus) && count($sc_roles_as_cus)){
										foreach($sc_roles_as_cus as $sr){
											if(in_array($sr,$user_info->roles)){
												$io_cs = true;
												break;
											}
										}
									}
								}
							}
							
							if($io_cs){
								if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
									$customer_data = $this->get_wc_customer_info_from_order($order_id);
								}else{
									$customer_data = $this->get_wc_customer_info($wc_cus_id);
								}							
								$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
							}else{
								$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_customer_to_sync_all_orders');
							}
							
						}else{
							$qbo_cus_id = $this->get_option('mw_wc_qbo_desk_customer_to_sync_all_orders');
						}
						*/
						
						/**/
						$wc_user_role = '';
						if($wc_cus_id>0){
							$user_info = get_userdata($wc_cus_id);
							if(isset($user_info->roles) && is_array($user_info->roles)){
								$wc_user_role = $user_info->roles[0];
							}
						}else{
							$wc_user_role = 'wc_guest_user';
						}
						
						if(!empty($wc_user_role)){
							$io_cs = true;
							$mw_wc_qbo_desk_aotc_rcm_data = get_option('mw_wc_qbo_desk_aotc_rcm_data');
							if(is_array($mw_wc_qbo_desk_aotc_rcm_data) && !empty($mw_wc_qbo_desk_aotc_rcm_data)){
								if(isset($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role]) && !empty($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role])){
									if($mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role] != 'Individual'){
										$io_cs = false;
									}
								}
							}
							
							if($io_cs){
								if($wc_cus_id>0){
									if($this->option_checked('mw_wc_qbo_desk_customer_qbo_check_billing_company')){
										$customer_data = $this->get_wc_customer_info_from_order($order_id);
									}else{
										$customer_data = $this->get_wc_customer_info($wc_cus_id);
									}							
									$qbo_cus_id = $this->if_qbo_customer_exists($customer_data);
								}else{
									$customer_data = $this->get_wc_customer_info_from_order($order_id);
									$qbo_cus_id = $this->if_qbo_guest_exists($customer_data);
								}
							}else{
								$qbo_cus_id = $mw_wc_qbo_desk_aotc_rcm_data[$wc_user_role];
							}
						}
						//
					}
				}				

				if(empty($qbo_cus_id)){
					$this->save_log(array('log_type'=>'Order','log_title'=>'Export Order Error #'.$order_id,'details'=>'QuickBooks Customer Not Found','status'=>0));
					return false;
				}

				if($qbo_cus_id!=''){
					$DocNumber = ($wc_inv_num!='')?$wc_inv_num:$wc_inv_id;
					$SalesReceipt = new QuickBooks_QBXML_Object_SalesReceipt();

					//$SalesReceipt->setCustomerName();
					$SalesReceipt->setCustomerListID($qbo_cus_id);
					
					if(!$this->option_checked('mw_wc_qbo_desk_use_qb_in_sr_so_ref_num')){
						$SalesReceipt->setRefNumber($DocNumber);
					}
					
					/**/
					$TemplateRef = $this->get_array_isset($invoice_data,'TemplateRef','');
					if(!empty($TemplateRef)){
						$SalesReceipt->set('TemplateRef ListID', $TemplateRef);
					}
					
					$inv_sr_txn_class = $this->get_option('mw_wc_qbo_desk_inv_sr_txn_qb_class');
					if($inv_sr_txn_class!=''){
						$SalesReceipt->setClassListID($inv_sr_txn_class);
					}
					
					//PO
					if($this->is_plugin_active('split-order-custom-po-for-myworks-quickbooks-desktop-sync') && $this->option_checked('mw_wc_qbo_desk_compt_p_ad_socpo_ed')){
						if(!empty($this->get_option('mw_wc_qbo_desk_compt_socpo_qbd_vendor'))){
							$DocNumber_Po = 'PO-'.$DocNumber;
							$SalesReceipt->set('PONumber',$DocNumber_Po);
						}
					}
					
					//NP Billing State - QBD Class Map					
					if($this->option_checked('mw_wc_qbo_desk_compt_np_bus_qbc_map_ed')){
						$_billing_state = $this->get_array_isset($invoice_data,'_billing_state','',true);
						if(!empty($_billing_state)){
							$bus_qbc_map = get_option('mw_wc_qbo_desk_np_bill_us_st_qb_cl_map');
							if(is_array($bus_qbc_map) && count($bus_qbc_map)){
								if(isset($bus_qbc_map[$_billing_state]) && !empty($bus_qbc_map[$_billing_state])){
									$qbd_classid = $bus_qbc_map[$_billing_state];
									$SalesReceipt->setClassListID($qbd_classid);
								}
							}
						}						
					}
					
					$wc_inv_date = $this->get_array_isset($invoice_data,'wc_inv_date','');
					$wc_inv_date = $this->format_date($wc_inv_date);
					if($wc_inv_date!=''){
						$SalesReceipt->setTxnDate($wc_inv_date);
					}

					$wc_inv_due_date = $this->get_array_isset($invoice_data,'wc_inv_due_date','');
					$wc_inv_due_date = $this->format_date($wc_inv_due_date);
					if($wc_inv_due_date!=''){
						$SalesReceipt->setDueDate($wc_inv_due_date);
					}
					
					
					$_payment_method = $this->get_array_isset($invoice_data,'_payment_method','',true);
					
					/*Count Total Amounts*/
					$_cart_discount = $this->get_array_isset($invoice_data,'_cart_discount',0);
					$_cart_discount_tax = $this->get_array_isset($invoice_data,'_cart_discount_tax',0);

					$_order_tax = (float) $this->get_array_isset($invoice_data,'_order_tax',0);
					$_order_shipping_tax = (float) $this->get_array_isset($invoice_data,'_order_shipping_tax',0);
					$_order_total_tax = ($_order_tax+$_order_shipping_tax);
					
					$order_shipping_total = $this->get_array_isset($invoice_data,'order_shipping_total',0);

					/*Qbd settings*/
					$qbo_is_sales_tax = true;
					$qbo_company_country = 'US';
					$qbo_is_shipping_allowed = false;

					/*Tax rates*/
					$qbo_tax_code = '';
					$apply_tax = false;
					$is_tax_applied = false;
					$is_inclusive = false;

					$qbo_tax_code_shipping = '';

					$tax_rate_id = 0;
					$tax_rate_id_2 = 0;

					$tax_details = (isset($invoice_data['tax_details']))?$invoice_data['tax_details']:array();
					
					//Tax Totals From tax Lines
					$calc_order_tax_totals_from_tax_lines = true;					
					if($calc_order_tax_totals_from_tax_lines){
						$_order_tax = 0;
						$_order_shipping_tax = 0;
						$_order_total_tax = 0;
						if(count($tax_details)){
							foreach($tax_details as $td){
								$_order_tax+=$td['tax_amount'];
								$_order_shipping_tax+=$td['shipping_tax_amount'];
								$_order_total_tax+=$td['tax_amount']+$td['shipping_tax_amount'];
							}
						}
					}
					
					$_order_total_tax = $this->qbd_limit_decimal_points($_order_total_tax);
					
					//TaxJar Settings
					$is_taxjar_active = false;
					$woocommerce_taxjar_integration_settings = get_option('woocommerce_taxjar-integration_settings');
					$wc_taxjar_enable_tax_calculation = 0;
					if(is_array($woocommerce_taxjar_integration_settings) && count($woocommerce_taxjar_integration_settings)){
						if(isset($woocommerce_taxjar_integration_settings['enabled']) && $woocommerce_taxjar_integration_settings['enabled']=='yes'){
							$wc_taxjar_enable_tax_calculation = 1;
						}
					}
					
					if($this->is_plugin_active('taxjar-simplified-taxes-for-woocommerce','taxjar-woocommerce') && $this->option_checked('mw_wc_qbo_desk_wc_taxjar_support') && $wc_taxjar_enable_tax_calculation=='1'){
						$is_taxjar_active = true;
						$qbo_is_sales_tax = false;
					}
					
					//Avatax Settings
					$is_avatax_active = false;
					$wc_avatax_enable_tax_calculation = get_option('wc_avatax_enable_tax_calculation');
					if($this->is_plugin_active('woocommerce-avatax') && $this->option_checked('mw_wc_qbo_desk_wc_avatax_support') && $wc_avatax_enable_tax_calculation=='yes'){
						$is_avatax_active = true;
						$qbo_is_sales_tax = false;
					}
					
					//
					$is_so_tax_as_li = false;
					if($this->option_checked('mw_wc_qbo_desk_odr_tax_as_li')){
						$is_so_tax_as_li = true;
						$qbo_is_sales_tax = false;
					}

					if($qbo_is_sales_tax){
						if(count($tax_details)){
							$tax_rate_id = $tax_details[0]['rate_id'];
						}

						if(count($tax_details)>1){
							if($tax_details[1]['tax_amount']>0){
								$tax_rate_id_2 = $tax_details[1]['rate_id'];
							}
						}

						/*
						if(count($tax_details)>1 && $qbo_is_shipping_allowed){
							foreach($tax_details as $td){
								if($td['tax_amount']==0 && $td['shipping_tax_amount']>0){
									$qbo_tax_code_shipping = $this->get_qbo_mapped_tax_code($td['rate_id'],0);
									break;
								}
							}
						}
						*/

						$qbo_tax_code = $this->get_qbo_mapped_tax_code($tax_rate_id,$tax_rate_id_2);
						if($qbo_tax_code!='' || $qbo_tax_code!='NON'){
							$apply_tax = true;
						}

						//$Tax_Code_Details = $this->mod_qbo_get_tx_dtls($qbo_tax_code);
						$is_qbo_dual_tax = false;

						/*
						if(count($Tax_Code_Details)){
							if($Tax_Code_Details['TaxGroup'] && count($Tax_Code_Details['TaxRateDetail'])>1){
								$is_qbo_dual_tax = true;
							}
						}

						$Tax_Rate_Ref = (isset($Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef']:'';
						$TaxPercent = $this->get_qbo_tax_rate_value_by_key($Tax_Rate_Ref);
						$Tax_Name = (isset($Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][0]['TaxRateRef_name']:'';

						$NetAmountTaxable = 0;

						if($is_qbo_dual_tax){
							$Tax_Rate_Ref_2 = (isset($Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef']:'';
							$TaxPercent_2 = $this->get_qbo_tax_rate_value_by_key($Tax_Rate_Ref_2);
							$Tax_Name_2 = (isset($Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef']))?$Tax_Code_Details['TaxRateDetail'][1]['TaxRateRef_name']:'';
							$NetAmountTaxable_2 = 0;
						}
						*/

						/*
						if($qbo_tax_code_shipping!=''){
							$Tax_Code_Details_Shipping = $this->mod_qbo_get_tx_dtls($qbo_tax_code_shipping);
							$Tax_Rate_Ref_Shipping = (isset($Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef']:'';
							$TaxPercent_Shipping = $this->get_qbo_tax_rate_value_by_key($Tax_Rate_Ref_Shipping);
							$Tax_Name_Shipping = (isset($Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef']))?$Tax_Code_Details_Shipping['TaxRateDetail'][0]['TaxRateRef_name']:'';
							$NetAmountTaxable_Shipping = 0;
						}
						*/

						$_prices_include_tax = $this->get_array_isset($invoice_data,'_prices_include_tax','no',true);
						if($qbo_is_sales_tax){
							$tax_type = $this->get_tax_type($_prices_include_tax);
							$is_inclusive = $this->is_tax_inclusive($tax_type);
						}
					}


					$qbo_inv_items = (isset($invoice_data['qbo_inv_items']))?$invoice_data['qbo_inv_items']:array();
					
					$is_bundle_order = false;
					$map_bundle_support = false;
					
					if(!$is_bundle_order){
						if(is_array($qbo_inv_items) && count($qbo_inv_items)){
							foreach($qbo_inv_items as $qbo_item){
								if($qbo_item['qbo_product_type'] == 'Group'){
									$map_bundle_support = true;
									$SalesReceiptLineGroup = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLineGroup();
									$SalesReceiptLineGroup->setItemListID($qbo_item["ItemRef"]);
									$Description = $qbo_item['Description'];
									$Qty = $qbo_item["Qty"];									
									$SalesReceiptLineGroup->setQuantity($Qty);
									
									if(!$this->option_checked('mw_wc_qbo_desk_skip_os_lid')){
										//$SalesReceiptLineGroup->setDesc($Description);
									}
									//TotalAmount
									$SalesReceipt->addSalesReceiptLineGroup($SalesReceiptLineGroup);
								}
							}
						}
					}
					
					if(is_array($qbo_inv_items) && count($qbo_inv_items)){
						foreach($qbo_inv_items as $qbo_item){
							
							if($map_bundle_support && $qbo_item['qbo_product_type'] == 'Group'){
								continue;
							}
							
							$SalesReceiptLine = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLine();
							//$SalesReceiptLine->setItemName($qbo_item['Description']);
							$SalesReceiptLine->setItemListID($qbo_item["ItemRef"]);
							if(isset($qbo_item["ClassRef"]) && $qbo_item["ClassRef"]!=''){
								//$SalesReceiptLine->setClassListID($qbo_item["ClassRef"]);
							}
							
							$Description = $qbo_item['Description'];
							if($this->option_checked('mw_wc_qbo_desk_add_sku_af_lid')){
								$li_item_id = ($qbo_item["variation_id"]>0)?$qbo_item["variation_id"]:$qbo_item["product_id"];
								$li_sku = get_post_meta( $li_item_id, '_sku', true );
								if($li_sku!=''){
									$Description.=' ('.$li_sku.')';
								}
							}
							
							//Extra Description
							if(isset($qbo_item["Qbd_Ext_Description"])){
								$Description.= $qbo_item["Qbd_Ext_Description"];
							}
							
							if(!$this->option_checked('mw_wc_qbo_desk_skip_os_lid') || $qbo_item["AllowPvLid"]){
								$SalesReceiptLine->setDesc($Description);
							}							
							
							$UnitPrice = $qbo_item["UnitPrice"];
							$Qty = $qbo_item["Qty"];
							$Amount = $Qty*$UnitPrice;
							$SalesReceiptLine->setRate($UnitPrice);
							$SalesReceiptLine->setQuantity($Qty);
							$SalesReceiptLine->setAmount($Amount);

							/*
							SerialNumber
							LotNumber
							ServiceDate
							*/

							if($qbo_is_sales_tax){
								if($apply_tax && $qbo_item["Taxed"]){
									$is_tax_applied = true;
									/*$TaxCodeRef = ($qbo_company_country=='US')?'TAX':$qbo_tax_code;*/
									if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')== 'Sales_Tax_Codes'){
										$TaxCodeRef =$qbo_tax_code;
									}else{
										$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
									}

									/*
									if($is_inclusive){
										$TaxInclusiveAmt = ($qbo_item['line_total']+$qbo_item['line_tax']);
									}
									*/
									if($TaxCodeRef!=''){
										$SalesReceiptLine->setSalesTaxCodeListID($TaxCodeRef);
									}
								}else{
									$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
									$SalesReceiptLine->setSalesTaxCodeListID($zero_rated_tax_code);
								}
							}
							
							if(!$qbo_is_sales_tax){
								$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
								$SalesReceiptLine->setSalesTaxCodeListID($zero_rated_tax_code);
							}
							
							if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync') && ($qbo_item["qbo_product_type"]=='Inventory' || $qbo_item["qbo_product_type"]=='InventoryAssembly')){
								$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
								if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){									
									if($this->is_inv_site_bin_allowed()){
										if (strpos($mw_wc_qbo_desk_compt_qbd_invt_site_ref, ':') !== false) {
											$site_bin_arr = explode(':',$mw_wc_qbo_desk_compt_qbd_invt_site_ref);
											if(is_array($site_bin_arr) && !empty($site_bin_arr)){
												$SalesReceiptLine->set('InventorySiteRef ListID' , $site_bin_arr[0]);
												if(isset($site_bin_arr[1])){
													$SalesReceiptLine->set('InventorySiteLocationRef ListID' , $site_bin_arr[1]);
												}
											}
										}
									}else{
										$SalesReceiptLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
									}
								}
							}

							$SalesReceipt->addSalesReceiptLine($SalesReceiptLine);
						}
					}
					
					//pgdf compatibility
					if($this->get_wc_fee_plugin_check()){
						$dc_gt_fees = (isset($invoice_data['dc_gt_fees']))?$invoice_data['dc_gt_fees']:array();
						if(is_array($dc_gt_fees) && count($dc_gt_fees)){
							foreach($dc_gt_fees as $df){
								$SalesReceiptLine = new QuickBooks_QBXML_Object_SalesReceipt_SalesReceiptLine();
								
								$UnitPrice = $df['_line_total'];
								$Qty = 1;
								$Amount = $Qty*$UnitPrice;
								
								$df_ItemRef = $this->get_wc_fee_qbo_product($df['name'],'',$invoice_data);
								$SalesReceiptLine->setItemListID($df_ItemRef);
								
								$SalesReceiptLine->setRate($UnitPrice);
								$SalesReceiptLine->setQuantity($Qty);
								$SalesReceiptLine->setAmount($Amount);
								
								$SalesReceiptLine->setDesc($df['name']);
								
								$_line_tax = $df['_line_tax'];
								if($_line_tax && $qbo_is_sales_tax){
									$is_tax_applied = true;
									if($this->get_option('mw_wc_qbo_desk_sl_tax_map_entity')== 'Sales_Tax_Codes'){
										$TaxCodeRef =$qbo_tax_code;
									}else{
										$TaxCodeRef = $this->get_option('mw_wc_qbo_desk_tax_rule_taxable');
									}
									
									if($TaxCodeRef!=''){
										$SalesReceiptLine->setSalesTaxCodeListID($TaxCodeRef);
									}
								}else{
									$zero_rated_tax_code = $this->get_qbo_zero_rated_tax_code($qbo_company_country);
									$SalesReceiptLine->setSalesTaxCodeListID($zero_rated_tax_code);
								}
								
								/*
								if($this->option_checked('mw_wc_qbo_desk_compt_qbd_adv_invt_sync') && ($qbo_item["qbo_product_type"]=='Inventory' || $qbo_item["qbo_product_type"]=='InventoryAssembly')){
									$mw_wc_qbo_desk_compt_qbd_invt_site_ref = $this->get_option('mw_wc_qbo_desk_compt_qbd_invt_site_ref');
									if($mw_wc_qbo_desk_compt_qbd_invt_site_ref!=''){
										$SalesReceiptLine->set('InventorySiteRef ListID' , $mw_wc_qbo_desk_compt_qbd_invt_site_ref);
									}
								}
								*/
								
								$SalesReceipt->addSalesReceiptLine($SalesReceiptLine);
							}
							
						}						
					}
					
					/*Add SalesReceipt Coupons*/
					$used_coupons  = (isset($invoice_data['used_coupons']))?$invoice_data['used_coupons']:array();
					$qbo_is_discount_allowed = true;
					if($this->option_checked('mw_wc_qbo_desk_no_ad_discount_li')){
						$qbo_is_discount_allowed = false;
					}
					
					if($qbo_is_discount_allowed && count($used_coupons)){
						foreach($used_coupons as $coupon){
							$coupon_name = $coupon['name'];
							$coupon_discount_amount = $coupon['discount_amount'];
							$coupon_discount_amount = -1 * abs($coupon_discount_amount);
							$coupon_discount_amount_tax = $coupon['discount_amount_tax'];

							$coupon_product_arr = $this->get_mapped_coupon_product